#line 1 "dfa_s390.cpp"
//
// Copyright (c) 2017, 2021, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2017, 2020 SAP SE. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_s390.hpp"
#include "oops/compressedOops.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"
#include "utilities/powerOfTwo.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 1;

// AttributeForm 
static const int ins_cost = DEFAULT_COST;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_is_TrapBasedCheckNode = true;

// AttributeForm 
static const int ins_num_consts = 0;

// AttributeForm 
static const int ins_alignment = 1;

// AttributeForm 
static const int ins_cannot_rematerialize = false;

// AttributeForm 
static const int ins_should_rematerialize = false;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  assert(rule < (1 << 15), "too many rules"); _cost[ (result) ] = cost; _rule[ (result) ] = (rule << 1) | 0x1;

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IREGN, iRegN_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, noArg_iRegN_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, rarg1RegN_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, rarg2RegN_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, rarg3RegN_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, rarg4RegN_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, rarg5RegN_rule, c+1)
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(NOODD_IREGI, noOdd_iRegI_rule, c)
        DFA_PRODUCTION(IREGI, iRegI_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, revenRegI_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, roddRegI_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGI, rarg1RegI_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, rarg2RegI_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, rarg3RegI_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, rarg4RegI_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, rarg5RegI_rule, c+1+1)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(NOARG_IREGI, noArg_iRegI_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IREGI, iRegI_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)	  // overwrites higher cost rule
        DFA_PRODUCTION(REVENREGI, revenRegI_rule, c+1)	  // overwrites higher cost rule
        DFA_PRODUCTION(RODDREGI, roddRegI_rule, c+1)	  // overwrites higher cost rule
        DFA_PRODUCTION(RARG1REGI, rarg1RegI_rule, c+1)	  // overwrites higher cost rule
        DFA_PRODUCTION(RARG2REGI, rarg2RegI_rule, c+1)	  // overwrites higher cost rule
        DFA_PRODUCTION(RARG3REGI, rarg3RegI_rule, c+1)	  // overwrites higher cost rule
        DFA_PRODUCTION(RARG4REGI, rarg4RegI_rule, c+1)	  // overwrites higher cost rule
        DFA_PRODUCTION(RARG5REGI, rarg5RegI_rule, c+1)	  // overwrites higher cost rule
    }
     DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, MEMORY_REF_COST)	  // overwrites higher cost rule
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(RSCRATCH2REGP, rscratch2RegP_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(LOCK_PTR_REGP, lock_ptr_RegP_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(MEMORYREGP, memoryRegP_rule, c)
        DFA_PRODUCTION(INDIRECT, indirect_rule, c+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(THREADREGP, threadRegP_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IREGP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, noArg_iRegP_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, rarg1RegP_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, rarg2RegP_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, rarg3RegP_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, rarg4RegP_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, rarg5RegP_rule, c+1)
        DFA_PRODUCTION(REVENREGP, revenRegP_rule, c+1)
        DFA_PRODUCTION(RODDREGP, roddRegP_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, inline_cache_regP_rule, c+1)
    }
     DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, MEMORY_REF_COST)	  // overwrites higher cost rule
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(RSCRATCHREGF, rscratchRegF_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(REGF, regF_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
     DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, MEMORY_REF_COST)	  // overwrites higher cost rule
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(RSCRATCHREGD, rscratchRegD_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(REGD, regD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
     DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, MEMORY_REF_COST)	  // overwrites higher cost rule
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IREGL, iRegL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, revenRegL_rule, c+1)
        DFA_PRODUCTION(RODDREGL, roddRegL_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, allRoddRegL_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, rarg1RegL_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, rarg5RegL_rule, c+1)
    }
     DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, MEMORY_REF_COST)	  // overwrites higher cost rule
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(TD_FLAGSREG, TD_flagsReg_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(FLAGSREG, flagsReg_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION(_ABSD_REGD_, _AbsD_regD__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD] + DEFAULT_COST;
        DFA_PRODUCTION(REGD, absD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(_ABSF_REGF_, _AbsF_regF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF] + DEFAULT_COST;
        DFA_PRODUCTION(REGF, absF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_AbsI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION(_ABSI_IREGI_, _AbsI_iRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST_LOW;
        DFA_PRODUCTION(IREGI, absI_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, absI_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, absI_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, absI_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, absI_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, absI_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, absI_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, absI_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, absI_reg_rule, c+1)
    }
}
void  State::_sub_Op_AbsL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST_LOW;
        DFA_PRODUCTION(IREGL, absL_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, absL_reg_rule, c+1)
        DFA_PRODUCTION(RODDREGL, absL_reg_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, absL_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, absL_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, absL_reg_rule, c+1)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORYRX_) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORYRX_]+_kids[1]->_cost[REGD] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGD, addD_reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, addD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, addD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORYRX_) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORYRX_]+_kids[1]->_cost[REGF] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGF, addF_reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, addF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, addF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORYRSY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORYRSY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION(_ADDI__LOADI_MEMORYRSY__IMMI8, _AddI__LoadI_memoryRSY__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, addI_Reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, addI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, addI_Reg_mem_0_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, addI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, addI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, addI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, addI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, addI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, addI_Reg_mem_0_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_Reg_mem_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], IMMI20) &&
        (
#line 5796 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 371 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_IREGI_IREGI]+_kids[1]->_cost[IMMI20] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_reg_imm20_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_reg_imm20_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_reg_imm20_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI12) &&
        (
#line 5785 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD
#line 409 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_IREGI_IREGI]+_kids[1]->_cost[UIMMI12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_reg_imm12_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_ADDI_IREGI_IREGI, _AddI_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI20) &&
        (
#line 5774 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 451 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI20] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_imm20_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_imm20_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_imm20_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI12) &&
        (
#line 5762 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 489 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_imm12_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST_HIGH;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 5738 "src/hotspot/cpu/s390/s390.ad"
 VM_Version::has_DistinctOpnds()
#line 560 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_imm16_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_imm16_RISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_imm16_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_imm16_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_imm16_CISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_imm16_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 5709 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_DistinctOpnds()
#line 631 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_reg_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_reg_RISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_reg_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_reg_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_reg_reg_CISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_reg_reg_CISC_rule, c+1)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORYRSY_) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORYRSY_]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION(_ADDL__LOADL_MEMORYRSY__IMML8, _AddL__LoadL_memoryRSY__immL8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        (
#line 5968 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 708 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_IREGL_IREGL]+_kids[1]->_cost[IMML20] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, addL_reg_reg_imm20_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, addL_reg_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RODDREGL, addL_reg_reg_imm20_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, addL_reg_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, addL_reg_reg_imm20_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        (
#line 5957 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD
#line 723 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_IREGL_IREGL]+_kids[1]->_cost[UIMML12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_ADDL_IREGL_IREGL, _AddL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_Reg_memI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_Reg_memI_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L__LOADI_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L__LOADI_MEMORY__] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_Reg_memI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_Reg_memI_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) &&
        (
#line 5922 "src/hotspot/cpu/s390/s390.ad"
 VM_Version::has_DistinctOpnds()
#line 852 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_imm16_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_imm16_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_imm16_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_imm16_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML32] + DEFAULT_COST_HIGH;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        (
#line 5886 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 929 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML20] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_imm20_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_imm20_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        (
#line 5875 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD
#line 958 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5862 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_DistinctOpnds()
#line 987 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_reg_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_reg_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_reg_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_reg_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_regI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_regI_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L_IREGI_] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_regI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_reg_regI_rule, c+1)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORYRSY_) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORYRSY_]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION(_ADDP__LOADP_MEMORYRSY__IMML8, _AddP__LoadP_memoryRSY__immL8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_IREGP_N2P_IREGL) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        (
#line 6134 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD && CompressedOops::base() == NULL && CompressedOops::shift() == 0
#line 1094 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_IREGP_N2P_IREGL]+_kids[1]->_cost[IMML20] + DEFAULT_COST;
        DFA_PRODUCTION(IREGP, addP_regN_reg_imm20_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(INDIRECT, addP_regN_reg_imm20_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(RODDREGP, addP_regN_reg_imm20_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_regN_reg_imm20_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MEMORYREGP_IREGL) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        (
#line 6123 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 1121 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MEMORYREGP_IREGL]+_kids[1]->_cost[IMML20] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_reg_imm20_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_imm20_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_reg_imm20_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_IREGP_N2P_IREGL) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        (
#line 6112 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD && CompressedOops::base() == NULL && CompressedOops::shift() == 0
#line 1186 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_IREGP_N2P_IREGL]+_kids[1]->_cost[UIMML12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_regN_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_regN_reg_imm12_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_regN_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_regN_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_ADDP_IREGP_N2P_IREGL, _AddP_iRegP_N2P_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MEMORYREGP_IREGL) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        (
#line 6101 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD
#line 1255 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MEMORYREGP_IREGL]+_kids[1]->_cost[UIMML12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_imm12_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMML32] + DEFAULT_COST_HIGH;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYREGP) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        (
#line 6076 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 1380 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORYREGP]+_kids[1]->_cost[IMML20] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_imm20_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm20_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_imm20_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_imm20_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IMML16) &&
        (
#line 6065 "src/hotspot/cpu/s390/s390.ad"
!PreferLAoverADD && VM_Version::has_DistinctOpnds()
#line 1445 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IMML16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_imm16_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm16_RISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_imm16_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_imm16_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMML16) &&
        (
#line 6052 "src/hotspot/cpu/s390/s390.ad"
!PreferLAoverADD && !VM_Version::has_DistinctOpnds()
#line 1510 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMML16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_imm16_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm16_CISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_imm16_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_imm16_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        (
#line 6039 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD
#line 1575 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[UIMML12] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_imm12_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm12_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_imm12_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_imm12_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6026 "src/hotspot/cpu/s390/s390.ad"
!PreferLAoverADD && VM_Version::has_DistinctOpnds()
#line 1640 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_reg_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_RISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_reg_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6012 "src/hotspot/cpu/s390/s390.ad"
!PreferLAoverADD && !VM_Version::has_DistinctOpnds()
#line 1705 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_reg_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_CISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_reg_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5998 "src/hotspot/cpu/s390/s390.ad"
 PreferLAoverADD
#line 1770 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_reg_LA_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_LA_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, addP_reg_reg_LA_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_reg_LA_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_IREGN__IREGL) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        
#line 3525 "src/hotspot/cpu/s390/s390.ad"
Matcher::narrow_oop_use_complex_address()
#line 1835 "dfa_s390.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_IREGN__IREGL]+_kids[1]->_cost[UIMML12]+1;
        DFA_PRODUCTION(INDOFFSET12INDEXNARROW, indOffset12indexNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c) {
        DFA_PRODUCTION(MEMORYRX, indOffset12indexNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MEMORYREGP_IREGL) && STATE__VALID_CHILD(_kids[1], UIMML12) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MEMORYREGP_IREGL]+_kids[1]->_cost[UIMML12]+1;
        DFA_PRODUCTION(INDOFFSET12INDEX, indOffset12index_rule, c)
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c) {
        DFA_PRODUCTION(MEMORYRX, indOffset12index_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_IREGN__IREGL) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        
#line 3497 "src/hotspot/cpu/s390/s390.ad"
Matcher::narrow_oop_use_complex_address()
#line 1854 "dfa_s390.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_IREGN__IREGL]+_kids[1]->_cost[IMML20]+1;
        DFA_PRODUCTION(INDOFFSET20INDEXNARROW, indOffset20indexNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset20indexNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c) {
        DFA_PRODUCTION(MEMORYRXY, indOffset20indexNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_ADDP__DECODEN_IREGN__IREGL, _AddP__DecodeN_iRegN__iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MEMORYREGP_IREGL) && STATE__VALID_CHILD(_kids[1], IMML20) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MEMORYREGP_IREGL]+_kids[1]->_cost[IMML20]+1;
        DFA_PRODUCTION(INDOFFSET20INDEX, indOffset20index_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset20index_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c) {
        DFA_PRODUCTION(MEMORYRXY, indOffset20index_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYREGP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORYREGP]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_ADDP_MEMORYREGP_IREGL, _AddP_memoryRegP_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYREGP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORYREGP]+_kids[1]->_cost[IREGL]+1;
        DFA_PRODUCTION(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c) {
        DFA_PRODUCTION(MEMORYRXY, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c) {
        DFA_PRODUCTION(MEMORYRX, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], UIMML12) &&
        
#line 3455 "src/hotspot/cpu/s390/s390.ad"
Matcher::narrow_oop_use_complex_address()
#line 1900 "dfa_s390.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[UIMML12]+1;
        DFA_PRODUCTION(INDOFFSET12NARROW, indOffset12Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c) {
        DFA_PRODUCTION(MEMORYRX, indOffset12Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c) {
        DFA_PRODUCTION(MEMORYRS, indOffset12Narrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYREGP) && STATE__VALID_CHILD(_kids[1], UIMML12) ) {
      unsigned int c = _kids[0]->_cost[MEMORYREGP]+_kids[1]->_cost[UIMML12]+1;
        DFA_PRODUCTION(INDOFFSET12, indOffset12_rule, c)
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c) {
        DFA_PRODUCTION(MEMORYRX, indOffset12_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c) {
        DFA_PRODUCTION(MEMORYRS, indOffset12_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMML20) &&
        
#line 3427 "src/hotspot/cpu/s390/s390.ad"
Matcher::narrow_oop_use_complex_address()
#line 1925 "dfa_s390.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMML20]+1;
        DFA_PRODUCTION(INDOFFSET20NARROW, indOffset20Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset20Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c) {
        DFA_PRODUCTION(MEMORYRXY, indOffset20Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c) {
        DFA_PRODUCTION(MEMORYRSY, indOffset20Narrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYREGP) && STATE__VALID_CHILD(_kids[1], IMML20) ) {
      unsigned int c = _kids[0]->_cost[MEMORYREGP]+_kids[1]->_cost[IMML20]+1;
        DFA_PRODUCTION(INDOFFSET20, indOffset20_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffset20_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c) {
        DFA_PRODUCTION(MEMORYRXY, indOffset20_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c) {
        DFA_PRODUCTION(MEMORYRSY, indOffset20_rule, c)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI_LL1) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI_LL1] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, andI_reg_uimmI_LL1_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, andI_reg_uimmI_LL1_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, andI_reg_uimmI_LL1_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, andI_reg_uimmI_LL1_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, andI_reg_uimmI_LL1_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, andI_reg_uimmI_LL1_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, andI_reg_uimmI_LL1_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, andI_reg_uimmI_LL1_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, andI_reg_uimmI_LL1_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI_LH1) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI_LH1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_reg_uimmI_LH1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, andI_reg_uimmI_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, andI_reg_uimmI_LH1_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, andI_reg_uimmI_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, andI_reg_uimmI_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, andI_reg_uimmI_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, andI_reg_uimmI_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, andI_reg_uimmI_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, andI_reg_uimmI_LH1_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI] + DEFAULT_COST_HIGH;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_reg_uimm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, andI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, andI_reg_uimm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, andI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, andI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, andI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, andI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, andI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, andI_reg_uimm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, andI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, andI_Reg_mem_0_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, andI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, andI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, andI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, andI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, andI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, andI_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, andI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, andI_Reg_mem_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, andI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, andI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, andI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, andI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, andI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, andI_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, andI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, andI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, andI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, andI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, andI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, andI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, andI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, andI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_32BITS] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, zeroExtend_long_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, zeroExtend_long_rule, c+1)
        DFA_PRODUCTION(RODDREGL, zeroExtend_long_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, zeroExtend_long_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, zeroExtend_long_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, zeroExtend_long_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, convI2L_mem_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, convI2L_mem_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, convI2L_mem_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, convI2L_mem_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, convI2L_mem_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, convI2L_mem_zex_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IMML_32BITS] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, convI2L_reg_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, convI2L_reg_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, convI2L_reg_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, convI2L_reg_zex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, convI2L_reg_zex_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML_HH1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML_HH1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_uimmL_HH1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_reg_uimmL_HH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_reg_uimmL_HH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_reg_uimmL_HH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_reg_uimmL_HH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_reg_uimmL_HH1_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML_HL1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML_HL1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_uimmL_HL1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_reg_uimmL_HL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_reg_uimmL_HL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_reg_uimmL_HL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_reg_uimmL_HL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_reg_uimmL_HL1_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML_LH1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML_LH1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_uimmL_LH1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_reg_uimmL_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_reg_uimmL_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_reg_uimmL_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_reg_uimmL_LH1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_reg_uimmL_LH1_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML_LL1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML_LL1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_uimmL_LL1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_reg_uimmL_LL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_reg_uimmL_LL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_reg_uimmL_LL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_reg_uimmL_LL1_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_reg_uimmL_LL1_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, andL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, andL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, andL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, andL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, andL_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_FFFFFFFF) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_FFFFFFFF] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, loadUI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, loadUI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadUI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, loadUI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, loadUI2L_rule, c+1)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 9958 "src/hotspot/cpu/s390/s390.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 2390 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+300;
        DFA_PRODUCTION(IREGI, array_equalsC_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, array_equalsC_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, array_equalsC_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, array_equalsC_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, array_equalsC_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, array_equalsC_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, array_equalsC_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, array_equalsC_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, array_equalsC_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 9944 "src/hotspot/cpu/s390/s390.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 2408 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, array_equalsB_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, array_equalsB_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, array_equalsB_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, array_equalsB_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, array_equalsB_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, array_equalsB_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, array_equalsB_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, array_equalsB_rule, c+1)
      }
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION(_BINARY_IREGP_IMMI, _Binary_iRegP_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMI16];
        DFA_PRODUCTION(_BINARY_IREGP_IMMI16, _Binary_iRegP_immI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMP) && STATE__VALID_CHILD(_kids[1], IMMI_1) ) {
      unsigned int c = _kids[0]->_cost[IMMP]+_kids[1]->_cost[IMMI_1];
        DFA_PRODUCTION(_BINARY_IMMP_IMMI_1, _Binary_immP_immI_1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_BINARY_IREGP_IREGI, _Binary_iRegP_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], RARG5REGI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[RARG5REGI];
        DFA_PRODUCTION(_BINARY_IREGP_RARG5REGI, _Binary_iRegP_rarg5RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], RARG2REGI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[RARG2REGI];
        DFA_PRODUCTION(_BINARY_IREGP_RARG2REGI, _Binary_iRegP_rarg2RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION(_BINARY_IREGP_IREGP, _Binary_iRegP_iRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORYRX_) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORYRX_]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_BINARY__LOADD_MEMORYRX__REGD, _Binary__LoadD_memoryRX__regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORYRX_) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORYRX_]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_BINARY__LOADF_MEMORYRX__REGF, _Binary__LoadF_memoryRX__regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORYRX_];
        DFA_PRODUCTION(_BINARY_REGD__LOADD_MEMORYRX_, _Binary_regD__LoadD_memoryRX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORYRX_];
        DFA_PRODUCTION(_BINARY_REGF__LOADF_MEMORYRX_, _Binary_regF__LoadF_memoryRX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RARG5REGN) && STATE__VALID_CHILD(_kids[1], IREGN_P2N) ) {
      unsigned int c = _kids[0]->_cost[RARG5REGN]+_kids[1]->_cost[IREGN_P2N];
        DFA_PRODUCTION(_BINARY_RARG5REGN_IREGN_P2N, _Binary_rarg5RegN_iRegN_P2N_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RARG5REGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[RARG5REGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_BINARY_RARG5REGI_IREGI, _Binary_rarg5RegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RARG5REGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[RARG5REGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_BINARY_RARG5REGL_IREGL, _Binary_rarg5RegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RARG5REGP) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[RARG5REGP]+_kids[1]->_cost[IREGP_N2P];
        DFA_PRODUCTION(_BINARY_RARG5REGP_IREGP_N2P, _Binary_rarg5RegP_iRegP_N2P_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16];
        DFA_PRODUCTION(_BINARY_IREGL_IMML16, _Binary_iRegL_immL16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_BINARY_IREGL_IREGL, _Binary_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPF) && STATE__VALID_CHILD(_kids[1], FLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOPF]+_kids[1]->_cost[FLAGSREG];
        DFA_PRODUCTION(_BINARY_CMPOPF_FLAGSREG, _Binary_cmpOpF_flagsReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION(_BINARY_IREGP_IMMP0, _Binary_iRegP_immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP_N2P];
        DFA_PRODUCTION(_BINARY_IREGP_IREGP_N2P, _Binary_iRegP_iRegP_N2P_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16];
        DFA_PRODUCTION(_BINARY_IREGI_IMMI16, _Binary_iRegI_immI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_BINARY_IREGI_IREGI, _Binary_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMN0];
        DFA_PRODUCTION(_BINARY_IREGN_IMMN0, _Binary_iRegN_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN_P2N) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN_P2N];
        DFA_PRODUCTION(_BINARY_IREGN_IREGN_P2N, _Binary_iRegN_iRegN_P2N_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG];
        DFA_PRODUCTION(_BINARY_CMPOP_FLAGSREG, _Binary_cmpOp_flagsReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION(_BINARY_IREGL_IREGN, _Binary_iRegL_iRegN_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(CMPOP, cmpOp_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(CMPOPF, cmpOpF_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(CMPOPT, cmpOpT_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 10728 "src/hotspot/cpu/s390/s390.ad"
UseByteReverseInstruction
#line 2576 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, bytes_reverse_int_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, bytes_reverse_int_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, bytes_reverse_int_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, bytes_reverse_int_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, bytes_reverse_int_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, bytes_reverse_int_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, bytes_reverse_int_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, bytes_reverse_int_rule, c+1)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 10739 "src/hotspot/cpu/s390/s390.ad"
UseByteReverseInstruction
#line 2596 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, bytes_reverse_long_rule, c+1)
        DFA_PRODUCTION(RODDREGL, bytes_reverse_long_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, bytes_reverse_long_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, bytes_reverse_long_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, bytes_reverse_long_rule, c+1)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, CallDynamicJavaDirect_dynTOC_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, CallStaticJavaDirect_dynTOC_rule, c)
    }
}
void  State::_sub_Op_CastDD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD] + DEFAULT_COST;
        DFA_PRODUCTION(REGD, castDD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_CastFF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF] + DEFAULT_COST;
        DFA_PRODUCTION(REGF, castFF_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, castII_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, castII_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, castII_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, castII_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, castII_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, castII_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, castII_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, castII_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, castII_rule, c+1)
    }
}
void  State::_sub_Op_CastLL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, castLL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, castLL_rule, c+1)
        DFA_PRODUCTION(RODDREGL, castLL_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, castLL_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, castLL_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, castLL_rule, c+1)
    }
}
void  State::_sub_Op_CastVV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, castVV_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, castVV_rule, c+1)
        DFA_PRODUCTION(RODDREGL, castVV_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, castVV_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, castVV_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, castVV_rule, c+1)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGP, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, castX2P_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, castX2P_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, castX2P_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, castX2P_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, castX2P_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, castX2P_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, castX2P_rule, c+1)
        DFA_PRODUCTION(INDIRECT, castX2P_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, castX2P_rule, c+1)
        DFA_PRODUCTION(RODDREGP, castX2P_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, castX2P_rule, c+1)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P];
        DFA_PRODUCTION(_CASTP2X_IREGP_N2P_, _CastP2X_iRegP_N2P__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, castP2X_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, castP2X_rule, c+1)
        DFA_PRODUCTION(RODDREGL, castP2X_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, castP2X_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, castP2X_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, castP2X_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, castP2X_loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, castP2X_loadP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, castP2X_loadP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, castP2X_loadP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, castP2X_loadP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, castP2X_loadP_rule, c+1)
      }
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + DEFAULT_COST;
        DFA_PRODUCTION(IREGP, castPP_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, castPP_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, castPP_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, castPP_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, castPP_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, castPP_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, castPP_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, castPP_rule, c+1)
        DFA_PRODUCTION(INDIRECT, castPP_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, castPP_rule, c+1)
        DFA_PRODUCTION(RODDREGP, castPP_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, castPP_rule, c+1)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + DEFAULT_COST;
        DFA_PRODUCTION(IREGP, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(INDIRECT, checkCastPP_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(RODDREGP, checkCastPP_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, checkCastPP_rule, c+1)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGP_N2P]+300;
        DFA_PRODUCTION(UNIVERSE, inlineCallClearArray_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IMML]+_kids[1]->_cost[IREGP_N2P]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, inlineCallClearArrayConstBig_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], SSLENDW) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[SSLENDW]+_kids[1]->_cost[IREGP_N2P]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, inlineCallClearArrayConst_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPF_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPF_FLAGSREG]+_kids[1]->_cost[_BINARY_REGD_REGD]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(REGD, cmovD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPF_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPF_FLAGSREG]+_kids[1]->_cost[_BINARY_REGF_REGF]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(REGF, cmovF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IMMI16) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGI_IMMI16]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGI, cmovI_imm_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, cmovI_imm_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, cmovI_imm_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, cmovI_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, cmovI_imm_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, cmovI_imm_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, cmovI_imm_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, cmovI_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, cmovI_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, cmovI_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, cmovI_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, cmovI_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, cmovI_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, cmovI_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, cmovI_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, cmovI_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, cmovI_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IMML16) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGL_IMML16]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGL, cmovL_imm_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, cmovL_imm_rule, c+1)
        DFA_PRODUCTION(RODDREGL, cmovL_imm_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, cmovL_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, cmovL_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, cmovL_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, cmovL_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, cmovL_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, cmovL_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, cmovL_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, cmovL_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGP_IMMP0]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGP, cmovP_imm_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(INDIRECT, cmovP_imm_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(RODDREGP, cmovP_imm_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, cmovP_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGP_IREGP_N2P]+DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, cmovP_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, cmovP_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, cmovP_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_CMoveN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGN_IMMN0]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGN, cmovN_imm_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, cmovN_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, cmovN_imm_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, cmovN_imm_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, cmovN_imm_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, cmovN_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, cmovN_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN_P2N) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG]+_kids[1]->_cost[_BINARY_IREGN_IREGN_P2N]+DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, cmovN_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+1) {
        DFA_PRODUCTION(NOARG_IREGN, cmovN_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+1) {
        DFA_PRODUCTION(RARG1REGN, cmovN_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+1) {
        DFA_PRODUCTION(RARG2REGN, cmovN_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+1) {
        DFA_PRODUCTION(RARG3REGN, cmovN_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+1) {
        DFA_PRODUCTION(RARG4REGN, cmovN_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+1) {
        DFA_PRODUCTION(RARG5REGN, cmovN_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN_P2N) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN_P2N]+_kids[1]->_cost[IMMN0];
        DFA_PRODUCTION(_CMPN_IREGN_P2N_IMMN0, _CmpN_iRegN_P2N_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN_P2N) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN_P2N]+_kids[1]->_cost[IMMN0] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, compN_iRegN_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMNKLASS) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMNKLASS] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compNKlass_iRegN_immN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN_P2N) && STATE__VALID_CHILD(_kids[1], IMMN) ) {
      unsigned int c = _kids[0]->_cost[IREGN_P2N]+_kids[1]->_cost[IMMN] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compN_iRegN_immN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN_P2N) && STATE__VALID_CHILD(_kids[1], IREGN_P2N) ) {
      unsigned int c = _kids[0]->_cost[IREGN_P2N]+_kids[1]->_cost[IREGN_P2N] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compN_iRegN_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMDPM0) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMDPM0] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, cmpD0_cc_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, cmpD_cc_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, cmpD_cc_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+DEFAULT_COST * 5 + BRANCH_COST;
        DFA_PRODUCTION(IREGI, cmpD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, cmpD_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, cmpD_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, cmpD_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, cmpD_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, cmpD_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, cmpD_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, cmpD_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, cmpD_reg_rule, c+1)
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMFPM0) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMFPM0] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, cmpF0_cc_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, cmpF_cc_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, cmpF_cc_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+DEFAULT_COST * 5 + BRANCH_COST;
        DFA_PRODUCTION(IREGI, cmpF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, cmpF_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, cmpF_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, cmpF_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, cmpF_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, cmpF_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, cmpF_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, cmpF_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, cmpF_reg_rule, c+1)
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_RARG2REGP_RARG3REGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_RARG2REGP_RARG3REGP]+_kids[1]->_cost[IMMP0]+10 * DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, partialSubtypeCheck_vs_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION(_CMPI_IREGI_IMMI8, _CmpI_iRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_CMPI_IREGI_IREGI, _CmpI_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compI_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_0] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compI_reg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compI_reg_imm16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION(_CMPL_IREGL_IMML8, _CmpL_iRegL_immL8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_CMPL_IREGL_IREGL, _CmpL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L__LOADI_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L__LOADI_MEMORY__] + MEMORY_REF_COST;
        DFA_PRODUCTION(FLAGSREG, compL_reg_memI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMML_0) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IMML_0] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_conv_reg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_0] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_reg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_reg_imm16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML32] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_reg_imm32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L_IREGI_] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_reg_regI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+DEFAULT_COST * 5 + BRANCH_COST;
        DFA_PRODUCTION(IREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, cmpL3_reg_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, cmpL3_reg_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, cmpL3_reg_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, cmpL3_reg_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, cmpL3_reg_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, cmpL3_reg_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, cmpL3_reg_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, cmpL3_reg_reg_rule, c+1)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_0] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, cmpLTMask_reg_zero_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, cmpLTMask_reg_zero_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, cmpLTMask_reg_zero_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, cmpLTMask_reg_zero_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, cmpLTMask_reg_zero_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, cmpLTMask_reg_zero_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, cmpLTMask_reg_zero_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, cmpLTMask_reg_zero_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+2 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, cmpLTMask_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, cmpLTMask_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, cmpLTMask_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, cmpLTMask_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, cmpLTMask_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, cmpLTMask_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, cmpLTMask_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, cmpLTMask_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _DECODEN_IMMN8_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_DECODEN_IMMN8_];
        DFA_PRODUCTION(_CMPP__DECODEN_IREGN___DECODEN_IMMN8_, _CmpP__DecodeN_iRegN___DecodeN_immN8__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION(_CMPP__DECODEN_IREGN__IMMP0, _CmpP__DecodeN_iRegN__immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP8) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP8];
        DFA_PRODUCTION(_CMPP_IREGP_IMMP8, _CmpP_iRegP_immP8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _DECODEN_IREGN_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_DECODEN_IREGN_];
        DFA_PRODUCTION(_CMPP__DECODEN_IREGN___DECODEN_IREGN_, _CmpP__DecodeN_iRegN___DecodeN_iRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION(_CMPP_IREGP_IREGP, _CmpP_iRegP_iRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LOADP_MEMORY_] + MEMORY_REF_COST;
        DFA_PRODUCTION(FLAGSREG, compP_reg_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 8458 "src/hotspot/cpu/s390/s390.ad"
CompressedOops::base() == NULL && CompressedOops::shift() == 0
#line 3329 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMP0] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compP_decode_reg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IMMP0] + DEFAULT_COST_LOW;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compP_reg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IREGP_N2P] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION(_CMPP_IREGP_N2P_IMMP0, _CmpP_iRegP_N2P_immP0_rule, c)
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI8) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI8];
        DFA_PRODUCTION(_CMPU_IREGI_UIMMI8, _CmpU_iRegI_uimmI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
        DFA_PRODUCTION(FLAGSREG, compU_reg_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compU_reg_uimm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_CMPU_IREGI_IREGI, _CmpU_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI16];
        DFA_PRODUCTION(_CMPU_IREGI_UIMMI16, _CmpU_iRegI_uimmI16_rule, c)
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML32] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, compUL_reg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, compUL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RARG5REGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_RARG5REGI_IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, compareAndSwapI_bool_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, compareAndSwapI_bool_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, compareAndSwapI_bool_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, compareAndSwapI_bool_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, compareAndSwapI_bool_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, compareAndSwapI_bool_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, compareAndSwapI_bool_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, compareAndSwapI_bool_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, compareAndSwapI_bool_rule, c+1)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RARG5REGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_RARG5REGL_IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, compareAndSwapL_bool_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, compareAndSwapL_bool_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, compareAndSwapL_bool_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, compareAndSwapL_bool_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, compareAndSwapL_bool_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, compareAndSwapL_bool_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, compareAndSwapL_bool_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, compareAndSwapL_bool_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, compareAndSwapL_bool_rule, c+1)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RARG5REGP_IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_RARG5REGP_IREGP_N2P] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, compareAndSwapP_bool_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, compareAndSwapP_bool_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, compareAndSwapP_bool_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, compareAndSwapP_bool_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, compareAndSwapP_bool_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, compareAndSwapP_bool_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, compareAndSwapP_bool_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, compareAndSwapP_bool_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, compareAndSwapP_bool_rule, c+1)
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RARG5REGN_IREGN_P2N) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_RARG5REGN_IREGN_P2N] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, compareAndSwapN_bool_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, compareAndSwapN_bool_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, compareAndSwapN_bool_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, compareAndSwapN_bool_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, compareAndSwapN_bool_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, compareAndSwapN_bool_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, compareAndSwapN_bool_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, compareAndSwapN_bool_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, compareAndSwapN_bool_rule, c+1)
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 5629 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadAndALUAtomicV1()
#line 3460 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGI]+MEMORY_REF_COST + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, addI_mem_reg_atomic_z196_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, addI_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, addI_mem_reg_atomic_z196_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, addI_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, addI_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, addI_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, addI_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, addI_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, addI_mem_reg_atomic_z196_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGI]+MEMORY_REF_COST+100*DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_mem_reg_atomic_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_mem_reg_atomic_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_mem_reg_atomic_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMMI]+MEMORY_REF_COST+200*DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_mem_imm32_atomic_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_mem_imm32_atomic_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_mem_imm32_atomic_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMMI16]+MEMORY_REF_COST+100*DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_mem_imm16_atomic_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, addI_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, addI_mem_imm16_atomic_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, addI_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, addI_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, addI_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, addI_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, addI_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, addI_mem_imm16_atomic_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 5398 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_AtomicMemWithImmALUOps() && n->as_LoadStore()->result_not_used()
#line 3577 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMMI8] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, addI_mem_imm8_atomic_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 5640 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadAndALUAtomicV1()
#line 3588 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGL]+MEMORY_REF_COST + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, addL_mem_reg_atomic_z196_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, addL_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RODDREGL, addL_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, addL_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, addL_mem_reg_atomic_z196_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, addL_mem_reg_atomic_z196_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGL]+MEMORY_REF_COST+100*DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_mem_reg_atomic_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_mem_reg_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_mem_reg_atomic_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMML32]+MEMORY_REF_COST+100*DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_mem_imm32_atomic_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_mem_imm32_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_mem_imm32_atomic_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMML16]+MEMORY_REF_COST+100*DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_mem_imm16_atomic_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, addL_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, addL_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, addL_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, addL_mem_imm16_atomic_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, addL_mem_imm16_atomic_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        (
#line 5518 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_AtomicMemWithImmALUOps() && n->as_LoadStore()->result_not_used()
#line 3675 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMML8] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, addL_mem_imm8_atomic_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, xchgI_reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, xchgI_reg_mem_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, xchgI_reg_mem_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, xchgI_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, xchgI_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, xchgI_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, xchgI_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, xchgI_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, xchgI_reg_mem_rule, c+1)
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, xchgL_reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, xchgL_reg_mem_rule, c+1)
        DFA_PRODUCTION(RODDREGL, xchgL_reg_mem_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, xchgL_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, xchgL_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, xchgL_reg_mem_rule, c+1)
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGP] + DEFAULT_COST;
        DFA_PRODUCTION(IREGP, xchgP_reg_mem_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(INDIRECT, xchgP_reg_mem_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(RODDREGP, xchgP_reg_mem_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, xchgP_reg_mem_rule, c+1)
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IREGN] + DEFAULT_COST;
        DFA_PRODUCTION(IREGN, xchgN_reg_mem_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, xchgN_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, xchgN_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, xchgN_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, xchgN_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, xchgN_reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, xchgN_reg_mem_rule, c+1)
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 2964 "src/hotspot/cpu/s390/s390.ad"
n->get_narrowcon() == 0
#line 3749 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMN0, immN0_rule, c)
        DFA_PRODUCTION(IREGN, loadConN0_rule, c+DEFAULT_COST_LOW)
        DFA_PRODUCTION(NOARG_IREGN, loadConN0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG1REGN, loadConN0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG2REGN, loadConN0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG3REGN, loadConN0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG4REGN, loadConN0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG5REGN, loadConN0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c+DEFAULT_COST_LOW)
    }
    if(         
#line 2955 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm8(n->get_narrowcon())
#line 3765 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMN8, immN8_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c+DEFAULT_COST) {
        DFA_PRODUCTION(IREGN, loadConN_rule, c+DEFAULT_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(NOARG_IREGN, loadConN_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG1REGN, loadConN_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG2REGN, loadConN_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG3REGN, loadConN_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG4REGN, loadConN_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG5REGN, loadConN_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c+DEFAULT_COST) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c+DEFAULT_COST)
      }
    }
   if ( /* IREGN KNOWN_VALID || */ _cost[IREGN] > DEFAULT_COST) {
     DFA_PRODUCTION(IREGN, loadConN_rule, DEFAULT_COST)
   }
   if ( /* NOARG_IREGN KNOWN_VALID || */ _cost[NOARG_IREGN] > DEFAULT_COST+1) {
     DFA_PRODUCTION(NOARG_IREGN, loadConN_rule, DEFAULT_COST+1)
   }
   if ( /* RARG1REGN KNOWN_VALID || */ _cost[RARG1REGN] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG1REGN, loadConN_rule, DEFAULT_COST+1)
   }
   if ( /* RARG2REGN KNOWN_VALID || */ _cost[RARG2REGN] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG2REGN, loadConN_rule, DEFAULT_COST+1)
   }
   if ( /* RARG3REGN KNOWN_VALID || */ _cost[RARG3REGN] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG3REGN, loadConN_rule, DEFAULT_COST+1)
   }
   if ( /* RARG4REGN KNOWN_VALID || */ _cost[RARG4REGN] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG4REGN, loadConN_rule, DEFAULT_COST+1)
   }
   if ( /* RARG5REGN KNOWN_VALID || */ _cost[RARG5REGN] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG5REGN, loadConN_rule, DEFAULT_COST+1)
   }
   if ( /* IREGN_P2N KNOWN_VALID || */ _cost[IREGN_P2N] > DEFAULT_COST) {
     DFA_PRODUCTION(IREGN_P2N, iRegN_rule, DEFAULT_COST)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION(IREGN, loadConNKlass_rule, c+DEFAULT_COST)
        DFA_PRODUCTION(NOARG_IREGN, loadConNKlass_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG1REGN, loadConNKlass_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG2REGN, loadConNKlass_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG3REGN, loadConNKlass_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG4REGN, loadConNKlass_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG5REGN, loadConNKlass_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c+DEFAULT_COST)
    }
     DFA_PRODUCTION(IREGN, loadConNKlass_rule, DEFAULT_COST)	  // overwrites higher cost rule
     DFA_PRODUCTION(NOARG_IREGN, loadConNKlass_rule, DEFAULT_COST+1)	  // overwrites higher cost rule
     DFA_PRODUCTION(RARG1REGN, loadConNKlass_rule, DEFAULT_COST+1)	  // overwrites higher cost rule
     DFA_PRODUCTION(RARG2REGN, loadConNKlass_rule, DEFAULT_COST+1)	  // overwrites higher cost rule
     DFA_PRODUCTION(RARG3REGN, loadConNKlass_rule, DEFAULT_COST+1)	  // overwrites higher cost rule
     DFA_PRODUCTION(RARG4REGN, loadConNKlass_rule, DEFAULT_COST+1)	  // overwrites higher cost rule
     DFA_PRODUCTION(RARG5REGN, loadConNKlass_rule, DEFAULT_COST+1)	  // overwrites higher cost rule
     DFA_PRODUCTION(IREGN_P2N, iRegN_rule, DEFAULT_COST)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 2992 "src/hotspot/cpu/s390/s390.ad"
jlong_cast(n->getd()) == 0
#line 3849 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMDP0, immDp0_rule, c)
        DFA_PRODUCTION(REGD, loadConD0_rule, c+DEFAULT_COST_LOW)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+DEFAULT_COST_LOW+MEMORY_REF_COST)
    }
    if(         
#line 2983 "src/hotspot/cpu/s390/s390.ad"
n->getd() == 0
#line 3859 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMDPM0, immDpm0_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(REGD, loadConD_dynTOC_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST+MEMORY_REF_COST)
      }
    }
   if ( /* REGD KNOWN_VALID || */ _cost[REGD] > MEMORY_REF_COST) {
     DFA_PRODUCTION(REGD, loadConD_dynTOC_rule, MEMORY_REF_COST)
   }
   if ( /* STACKSLOTD KNOWN_VALID || */ _cost[STACKSLOTD] > MEMORY_REF_COST+MEMORY_REF_COST) {
     DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, MEMORY_REF_COST+MEMORY_REF_COST)
   }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 3018 "src/hotspot/cpu/s390/s390.ad"
jint_cast(n->getf()) == 0
#line 3885 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMFP0, immFp0_rule, c)
        DFA_PRODUCTION(REGF, loadConF0_rule, c+DEFAULT_COST_LOW)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+DEFAULT_COST_LOW+MEMORY_REF_COST)
    }
    if(         
#line 3009 "src/hotspot/cpu/s390/s390.ad"
n->getf() == 0
#line 3895 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMFPM0, immFpm0_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(REGF, loadConF_dynTOC_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST+MEMORY_REF_COST)
      }
    }
   if ( /* REGF KNOWN_VALID || */ _cost[REGF] > MEMORY_REF_COST) {
     DFA_PRODUCTION(REGF, loadConF_dynTOC_rule, MEMORY_REF_COST)
   }
   if ( /* STACKSLOTF KNOWN_VALID || */ _cost[STACKSLOTF] > MEMORY_REF_COST+MEMORY_REF_COST) {
     DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, MEMORY_REF_COST+MEMORY_REF_COST)
   }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 2705 "src/hotspot/cpu/s390/s390.ad"
(_n_get_int__ & 0xFFFF) == 0xFFFF
#line 3922 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI_LH1, uimmI_LH1_rule, c)
    }
    if(         
#line 2696 "src/hotspot/cpu/s390/s390.ad"
(_n_get_int__ & 0xFFFF0000) == 0xFFFF0000
#line 3930 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI_LL1, uimmI_LL1_rule, c)
    }
    if(         
#line 2687 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ >= 32 && _n_get_int__ <= 63
#line 3938 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_32_63, immI_32_63_rule, c)
    }
    if(         
#line 2678 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ == 255
#line 3946 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 2669 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ == 24
#line 3954 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 2660 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ == 16
#line 3962 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 2651 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ == 1
#line 3970 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 2625 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm(_n_get_int__, 5)
#line 3978 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI5, uimmI5_rule, c)
    }
    if(         
#line 2616 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm(_n_get_int__, 6)
#line 3986 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI6, uimmI6_rule, c)
    }
    if(         
#line 2607 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm8(_n_get_int__)
#line 3994 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI8, uimmI8_rule, c)
    }
    if(         
#line 2598 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm12(_n_get_int__)
#line 4002 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI12, uimmI12_rule, c)
    }
    if(         
#line 2589 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm16(_n_get_int__)
#line 4010 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI16, uimmI16_rule, c)
        DFA_PRODUCTION(IREGI, loadConUI16_rule, c+DEFAULT_COST)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+DEFAULT_COST+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadConUI16_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(NOODD_IREGI, loadConUI16_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(RODDREGI, loadConUI16_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG1REGI, loadConUI16_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG2REGI, loadConUI16_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG3REGI, loadConUI16_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG4REGI, loadConUI16_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG5REGI, loadConUI16_rule, c+DEFAULT_COST+1)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMMI, uimmI_rule, c)
    }
    if(         
#line 2568 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ != 0 && _n_get_int__ != -1
#line 4032 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_N0M1, immI_n0m1_rule, c)
    }
    if(         
#line 2559 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ == -1
#line 4040 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_MINUS1, immI_minus1_rule, c)
    }
    if(         
#line 2550 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ == 0
#line 4048 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI_0, immI_0_rule, c)
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c+DEFAULT_COST_LOW) {
        DFA_PRODUCTION(IREGI, loadConI_0_rule, c+DEFAULT_COST_LOW)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+DEFAULT_COST_LOW+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+DEFAULT_COST_LOW+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(REVENREGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+DEFAULT_COST_LOW+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RODDREGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG1REGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG2REGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG3REGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG4REGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG5REGI, loadConI_0_rule, c+DEFAULT_COST_LOW+1)
      }
    }
    if(         
#line 2541 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm8(_n_get_int__)
#line 4086 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI8, immI8_rule, c)
    }
    if(         
#line 2532 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm16(_n_get_int__)
#line 4094 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI16, immI16_rule, c)
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c+DEFAULT_COST_LOW) {
        DFA_PRODUCTION(IREGI, loadConI16_rule, c+DEFAULT_COST_LOW)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+DEFAULT_COST_LOW+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+DEFAULT_COST_LOW+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(REVENREGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+DEFAULT_COST_LOW+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, loadConI16_rule, c+DEFAULT_COST_LOW+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RODDREGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG1REGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG2REGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG3REGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG4REGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG5REGI, loadConI16_rule, c+DEFAULT_COST_LOW+1)
      }
    }
    if(         
#line 2523 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm20(_n_get_int__)
#line 4132 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI20, immI20_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMI, immI_rule, c)
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c+DEFAULT_COST) {
        DFA_PRODUCTION(IREGI, loadConI_rule, c+DEFAULT_COST)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+DEFAULT_COST+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+DEFAULT_COST+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(REVENREGI, loadConI_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+DEFAULT_COST+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, loadConI_rule, c+DEFAULT_COST+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RODDREGI, loadConI_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG1REGI, loadConI_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG2REGI, loadConI_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG3REGI, loadConI_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG4REGI, loadConI_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG5REGI, loadConI_rule, c+DEFAULT_COST+1)
      }
    }
    if(         
#line 2502 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ != 0 && _n_get_int__ != -1 && (_n_get_int__&0x0000ffff) != 0x0000ffff
#line 4174 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMS_N0M1, immS_n0m1_rule, c)
    }
    if(         
#line 2492 "src/hotspot/cpu/s390/s390.ad"
(_n_get_int__ == -1) || ((_n_get_int__&0x0000ffff) == 0x0000ffff)
#line 4182 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMS_MINUS1, immS_minus1_rule, c)
    }
    if(         
#line 2482 "src/hotspot/cpu/s390/s390.ad"
_n_get_int__ != 0 && _n_get_int__ != -1 && (_n_get_int__&0x000000ff) != 0x000000ff
#line 4190 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMB_N0M1, immB_n0m1_rule, c)
    }
    if(         
#line 2472 "src/hotspot/cpu/s390/s390.ad"
(_n_get_int__ == -1) || ((_n_get_int__&0x000000ff) == 0x000000ff)
#line 4198 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMB_MINUS1, immB_minus1_rule, c)
    }
   if ( /* IREGI KNOWN_VALID || */ _cost[IREGI] > DEFAULT_COST) {
     DFA_PRODUCTION(IREGI, loadConI_rule, DEFAULT_COST)
   }
   if ( /* STACKSLOTI KNOWN_VALID || */ _cost[STACKSLOTI] > DEFAULT_COST+MEMORY_REF_COST) {
     DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, DEFAULT_COST+MEMORY_REF_COST)
   }
   if ( /* REVENREGI KNOWN_VALID || */ _cost[REVENREGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(REVENREGI, loadConI_rule, DEFAULT_COST+1)
   }
   if ( /* NOODD_IREGI KNOWN_VALID || */ _cost[NOODD_IREGI] > DEFAULT_COST+1+1) {
     DFA_PRODUCTION(NOODD_IREGI, loadConI_rule, DEFAULT_COST+1+1)
   }
   if ( /* RODDREGI KNOWN_VALID || */ _cost[RODDREGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RODDREGI, loadConI_rule, DEFAULT_COST+1)
   }
   if ( /* RARG1REGI KNOWN_VALID || */ _cost[RARG1REGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG1REGI, loadConI_rule, DEFAULT_COST+1)
   }
   if ( /* RARG2REGI KNOWN_VALID || */ _cost[RARG2REGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG2REGI, loadConI_rule, DEFAULT_COST+1)
   }
   if ( /* RARG3REGI KNOWN_VALID || */ _cost[RARG3REGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG3REGI, loadConI_rule, DEFAULT_COST+1)
   }
   if ( /* RARG4REGI KNOWN_VALID || */ _cost[RARG4REGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG4REGI, loadConI_rule, DEFAULT_COST+1)
   }
   if ( /* RARG5REGI KNOWN_VALID || */ _cost[RARG5REGI] > DEFAULT_COST+1) {
     DFA_PRODUCTION(RARG5REGI, loadConI_rule, DEFAULT_COST+1)
   }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 2875 "src/hotspot/cpu/s390/s390.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 4239 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 2866 "src/hotspot/cpu/s390/s390.ad"
(_n_get_long__ & 0xFFFFFFFFFFFFL) == 0xFFFFFFFFFFFFL
#line 4247 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML_HH1, uimmL_HH1_rule, c)
    }
    if(         
#line 2857 "src/hotspot/cpu/s390/s390.ad"
(_n_get_long__ & 0xFFFF0000FFFFFFFFL) == 0xFFFF0000FFFFFFFFL
#line 4255 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML_HL1, uimmL_HL1_rule, c)
    }
    if(         
#line 2848 "src/hotspot/cpu/s390/s390.ad"
(_n_get_long__ & 0xFFFFFFFF0000FFFFL) == 0xFFFFFFFF0000FFFFL
#line 4263 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML_LH1, uimmL_LH1_rule, c)
    }
    if(         
#line 2839 "src/hotspot/cpu/s390/s390.ad"
(_n_get_long__ & 0xFFFFFFFFFFFF0000L) == 0xFFFFFFFFFFFF0000L
#line 4271 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML_LL1, uimmL_LL1_rule, c)
    }
    if(         
#line 2830 "src/hotspot/cpu/s390/s390.ad"
_n_get_long__ == 0L
#line 4279 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML_0, immL_0_rule, c)
        DFA_PRODUCTION(IREGL, loadConL_0_rule, c+DEFAULT_COST_LOW)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+DEFAULT_COST_LOW+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, loadConL_0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RODDREGL, loadConL_0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(ALLRODDREGL, loadConL_0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG1REGL, loadConL_0_rule, c+DEFAULT_COST_LOW+1)
        DFA_PRODUCTION(RARG5REGL, loadConL_0_rule, c+DEFAULT_COST_LOW+1)
    }
    if(         
#line 2822 "src/hotspot/cpu/s390/s390.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 4294 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML_FFFFFFFF, immL_FFFFFFFF_rule, c)
    }
    if(         
#line 2813 "src/hotspot/cpu/s390/s390.ad"
_n_get_long__ == 0xFFFFL
#line 4302 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML_FFFF, immL_FFFF_rule, c)
    }
    if(         
#line 2804 "src/hotspot/cpu/s390/s390.ad"
_n_get_long__ == 0xFFL
#line 4310 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML_FF, immL_FF_rule, c)
    }
    if(         
#line 2791 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm8(_n_get_long__)
#line 4318 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML8, uimmL8_rule, c)
    }
    if(         
#line 2782 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm12(_n_get_long__)
#line 4326 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML12, uimmL12_rule, c)
    }
    if(         
#line 2773 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm16(_n_get_long__)
#line 4334 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML16, uimmL16_rule, c)
    }
    if(         
#line 2764 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm32(_n_get_long__)
#line 4342 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(UIMML32, uimmL32_rule, c)
    }
    if(         
#line 2752 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm8(_n_get_long__)
#line 4350 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML8, immL8_rule, c)
    }
    if(         
#line 2743 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm16(_n_get_long__)
#line 4358 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML16, immL16_rule, c)
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c+DEFAULT_COST_LOW) {
        DFA_PRODUCTION(IREGL, loadConL16_rule, c+DEFAULT_COST_LOW)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+DEFAULT_COST_LOW+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+DEFAULT_COST_LOW+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(REVENREGL, loadConL16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RODDREGL, loadConL16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadConL16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG1REGL, loadConL16_rule, c+DEFAULT_COST_LOW+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+DEFAULT_COST_LOW+1) {
        DFA_PRODUCTION(RARG5REGL, loadConL16_rule, c+DEFAULT_COST_LOW+1)
      }
    }
    if(         
#line 2734 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm20(_n_get_long__)
#line 4387 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML20, immL20_rule, c)
    }
    if(         
#line 2725 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_simm32(_n_get_long__)
#line 4395 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML32, immL32_rule, c)
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c+DEFAULT_COST) {
        DFA_PRODUCTION(IREGL, loadConL32_rule, c+DEFAULT_COST)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+DEFAULT_COST+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+DEFAULT_COST+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(REVENREGL, loadConL32_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RODDREGL, loadConL32_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadConL32_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG1REGL, loadConL32_rule, c+DEFAULT_COST+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+DEFAULT_COST+1) {
        DFA_PRODUCTION(RARG5REGL, loadConL32_rule, c+DEFAULT_COST+1)
      }
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c+MEMORY_REF_COST_LO) {
        DFA_PRODUCTION(IREGL, loadConL_pcrelTOC_rule, c+MEMORY_REF_COST_LO)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST_LO+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST_LO+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(REVENREGL, loadConL_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RODDREGL, loadConL_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadConL_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG1REGL, loadConL_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG5REGL, loadConL_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
    }
    if(         
#line 2638 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm8(_n_get_long__-1)
#line 4449 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(SSLENDW, SSlenDW_rule, c)
    }
   if ( /* IREGL KNOWN_VALID || */ _cost[IREGL] > MEMORY_REF_COST_LO) {
     DFA_PRODUCTION(IREGL, loadConL_pcrelTOC_rule, MEMORY_REF_COST_LO)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > MEMORY_REF_COST_LO+MEMORY_REF_COST) {
     DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, MEMORY_REF_COST_LO+MEMORY_REF_COST)
   }
   if ( /* REVENREGL KNOWN_VALID || */ _cost[REVENREGL] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(REVENREGL, loadConL_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RODDREGL KNOWN_VALID || */ _cost[RODDREGL] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RODDREGL, loadConL_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* ALLRODDREGL KNOWN_VALID || */ _cost[ALLRODDREGL] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(ALLRODDREGL, loadConL_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG1REGL KNOWN_VALID || */ _cost[RARG1REGL] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG1REGL, loadConL_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG5REGL KNOWN_VALID || */ _cost[RARG5REGL] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG5REGL, loadConL_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 2927 "src/hotspot/cpu/s390/s390.ad"
n->get_ptr() == 0
#line 4480 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMP0, immP0_rule, c)
        DFA_PRODUCTION(IREGP, loadConP0_rule, c+DEFAULT_COST)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+DEFAULT_COST+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG1REGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG2REGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG3REGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG4REGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RARG5REGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(MEMORYREGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(INDIRECT, loadConP0_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+DEFAULT_COST+1+1)
        DFA_PRODUCTION(REVENREGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(RODDREGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP0_rule, c+DEFAULT_COST+1)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c+DEFAULT_COST)
    }
    if(         
#line 2914 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm8(n->get_ptr())
#line 4507 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMP8, immP8_rule, c)
    }
    if(         
#line 2905 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm16(n->get_ptr())
#line 4515 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMP16, immP16_rule, c)
    }
    if(         
#line 2896 "src/hotspot/cpu/s390/s390.ad"
Immediate::is_uimm32(n->get_ptr())
#line 4523 "dfa_s390.cpp"
 ) {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMP32, immP32_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+MEMORY_REF_COST_LO) {
        DFA_PRODUCTION(IREGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST_LO+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST_LO+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(NOARG_IREGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG1REGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG2REGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG3REGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG4REGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RARG5REGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(MEMORYREGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+MEMORY_REF_COST_LO+1+1) {
        DFA_PRODUCTION(INDIRECT, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+MEMORY_REF_COST_LO+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+MEMORY_REF_COST_LO+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+MEMORY_REF_COST_LO+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+MEMORY_REF_COST_LO+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+MEMORY_REF_COST_LO+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+MEMORY_REF_COST_LO+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+MEMORY_REF_COST_LO+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+MEMORY_REF_COST_LO+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+MEMORY_REF_COST_LO+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+MEMORY_REF_COST_LO+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(REVENREGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(RODDREGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+MEMORY_REF_COST_LO+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP_pcrelTOC_rule, c+MEMORY_REF_COST_LO+1)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c+MEMORY_REF_COST_LO) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c+MEMORY_REF_COST_LO)
      }
    }
   if ( /* IREGP KNOWN_VALID || */ _cost[IREGP] > MEMORY_REF_COST_LO) {
     DFA_PRODUCTION(IREGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO)
   }
   if ( /* STACKSLOTP KNOWN_VALID || */ _cost[STACKSLOTP] > MEMORY_REF_COST_LO+MEMORY_REF_COST) {
     DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, MEMORY_REF_COST_LO+MEMORY_REF_COST)
   }
   if ( /* NOARG_IREGP KNOWN_VALID || */ _cost[NOARG_IREGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(NOARG_IREGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG1REGP KNOWN_VALID || */ _cost[RARG1REGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG1REGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG2REGP KNOWN_VALID || */ _cost[RARG2REGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG2REGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG3REGP KNOWN_VALID || */ _cost[RARG3REGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG3REGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG4REGP KNOWN_VALID || */ _cost[RARG4REGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG4REGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RARG5REGP KNOWN_VALID || */ _cost[RARG5REGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RARG5REGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* MEMORYREGP KNOWN_VALID || */ _cost[MEMORYREGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(MEMORYREGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* INDIRECT KNOWN_VALID || */ _cost[INDIRECT] > MEMORY_REF_COST_LO+1+1) {
     DFA_PRODUCTION(INDIRECT, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1+1)
   }
   if ( /* MEMORY KNOWN_VALID || */ _cost[MEMORY] > MEMORY_REF_COST_LO+1+1) {
     DFA_PRODUCTION(MEMORY, indirect_rule, MEMORY_REF_COST_LO+1+1)
   }
   if ( /* MEMORYRXY KNOWN_VALID || */ _cost[MEMORYRXY] > MEMORY_REF_COST_LO+1+1) {
     DFA_PRODUCTION(MEMORYRXY, indirect_rule, MEMORY_REF_COST_LO+1+1)
   }
   if ( /* MEMORYRX KNOWN_VALID || */ _cost[MEMORYRX] > MEMORY_REF_COST_LO+1+1) {
     DFA_PRODUCTION(MEMORYRX, indirect_rule, MEMORY_REF_COST_LO+1+1)
   }
   if ( /* MEMORYRSY KNOWN_VALID || */ _cost[MEMORYRSY] > MEMORY_REF_COST_LO+1+1) {
     DFA_PRODUCTION(MEMORYRSY, indirect_rule, MEMORY_REF_COST_LO+1+1)
   }
   if ( /* MEMORYRS KNOWN_VALID || */ _cost[MEMORYRS] > MEMORY_REF_COST_LO+1+1) {
     DFA_PRODUCTION(MEMORYRS, indirect_rule, MEMORY_REF_COST_LO+1+1)
   }
   if ( /* REVENREGP KNOWN_VALID || */ _cost[REVENREGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(REVENREGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* RODDREGP KNOWN_VALID || */ _cost[RODDREGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(RODDREGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* INLINE_CACHE_REGP KNOWN_VALID || */ _cost[INLINE_CACHE_REGP] > MEMORY_REF_COST_LO+1) {
     DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP_pcrelTOC_rule, MEMORY_REF_COST_LO+1)
   }
   if ( /* IREGP_N2P KNOWN_VALID || */ _cost[IREGP_N2P] > MEMORY_REF_COST_LO) {
     DFA_PRODUCTION(IREGP_N2P, iRegP_rule, MEMORY_REF_COST_LO)
   }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+3 * DEFAULT_COST;
        DFA_PRODUCTION(IREGI, convP2B_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, convP2B_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, convP2B_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, convP2B_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, convP2B_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, convP2B_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, convP2B_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, convP2B_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, convP2B_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, convI2B_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, convI2B_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, convI2B_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, convI2B_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, convI2B_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, convI2B_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, convI2B_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, convI2B_rule, c+1)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD] + DEFAULT_COST;
        DFA_PRODUCTION(REGF, convD2F_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_MEMORYRX__) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_MEMORYRX__] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, sqrtF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_REGF__) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_REGF__] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, sqrtF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+2 * DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGI, convD2I_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, convD2I_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, convD2I_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, convD2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, convD2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, convD2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, convD2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, convD2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, convD2I_reg_rule, c+1)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+2 * DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGL, convD2L_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, convD2L_reg_rule, c+1)
        DFA_PRODUCTION(RODDREGL, convD2L_reg_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, convD2L_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, convD2L_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, convD2L_reg_rule, c+1)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRX) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRX] + DEFAULT_COST;
        DFA_PRODUCTION(REGD, convF2D_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, convF2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRX) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRX];
        DFA_PRODUCTION(_CONVF2D_MEMORYRX_, _ConvF2D_memoryRX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(_CONVF2D_REGF_, _ConvF2D_regF__rule, c)
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+2 * DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, convF2I_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, convF2I_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, convF2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, convF2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, convF2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, convF2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, convF2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, convF2I_reg_rule, c+1)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+2 * DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGL, convF2L_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, convF2L_reg_rule, c+1)
        DFA_PRODUCTION(RODDREGL, convF2L_reg_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, convF2L_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, convF2L_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, convF2L_reg_rule, c+1)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(REGD, convI2D_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(REGF, convI2F_ireg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 10445 "src/hotspot/cpu/s390/s390.ad"
false
#line 4817 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, expand_Repl2I_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, expand_Repl2I_reg_rule, c+1)
        DFA_PRODUCTION(RODDREGL, expand_Repl2I_reg_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, expand_Repl2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, expand_Repl2I_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, expand_Repl2I_reg_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, convI2L_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, convI2L_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, convI2L_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, convI2L_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, convI2L_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION(_CONVI2L_IREGI_, _ConvI2L_iRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, loadI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, loadI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, loadI2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, loadI2L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, loadUS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, loadUS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadUS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, loadUS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, loadUS2L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, loadS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, loadS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, loadS2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, loadS2L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, loadUB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, loadUB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadUB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, loadUB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, loadUB2L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, loadB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, loadB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, loadB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, loadB2L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, loadB2L_rule, c+1)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(REGD, convL2D_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(REGF, convL2F_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI_32_63] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, shrL_reg_imm6_L2I_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, shrL_reg_imm6_L2I_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, shrL_reg_imm6_L2I_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, shrL_reg_imm6_L2I_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, shrL_reg_imm6_L2I_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, shrL_reg_imm6_L2I_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, shrL_reg_imm6_L2I_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, shrL_reg_imm6_L2I_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, shrL_reg_imm6_L2I_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, convL2I_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, convL2I_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, convL2I_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, convL2I_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, convL2I_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, convL2I_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, convL2I_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, convL2I_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IMMI8) &&
        (
#line 9448 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 5048 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPI_IREGI_IMMI8]+BRANCH_COST+DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, testAndBranchLoopEnd_ImmFar_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) &&
        (
#line 9360 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 5057 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPI_IREGI_IREGI]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, testAndBranchLoopEnd_RegFar_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchLoopEndFar_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+3 * DEFAULT_COST;
        DFA_PRODUCTION(REVENREGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION(IREGI, countLeadingZerosI_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGI, countLeadingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGI, countLeadingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, countLeadingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, countLeadingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, countLeadingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, countLeadingZerosI_rule, c+1+1)
        DFA_PRODUCTION(NOODD_IREGI, countLeadingZerosI_rule, c+1)
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(REVENREGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION(IREGI, countLeadingZerosL_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGI, countLeadingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGI, countLeadingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, countLeadingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, countLeadingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, countLeadingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, countLeadingZerosL_rule, c+1+1)
        DFA_PRODUCTION(NOODD_IREGI, countLeadingZerosL_rule, c+1)
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+8 * DEFAULT_COST;
        DFA_PRODUCTION(REVENREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION(IREGI, countTrailingZerosI_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGI, countTrailingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGI, countTrailingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, countTrailingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, countTrailingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, countTrailingZerosI_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, countTrailingZerosI_rule, c+1+1)
        DFA_PRODUCTION(NOODD_IREGI, countTrailingZerosI_rule, c+1)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+8 * DEFAULT_COST;
        DFA_PRODUCTION(REVENREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION(IREGI, countTrailingZerosL_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGI, countTrailingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGI, countTrailingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, countTrailingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, countTrailingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, countTrailingZerosL_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, countTrailingZerosL_rule, c+1+1)
        DFA_PRODUCTION(NOODD_IREGI, countTrailingZerosL_rule, c+1)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(RARG1REGP, CreateException_rule, c)
        DFA_PRODUCTION(IREGP, CreateException_rule, c+1)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(MEMORYREGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(INDIRECT, CreateException_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(REVENREGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(RODDREGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, CreateException_rule, c+1+1)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c+1)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMN8) ) {
      unsigned int c = _kids[0]->_cost[IMMN8];
        DFA_PRODUCTION(_DECODEN_IMMN8_, _DecodeN_immN8__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 4784 "src/hotspot/cpu/s390/s390.ad"
(n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull ||
             n->bottom_type()->is_oopptr()->ptr() == TypePtr::Constant) &&
            CompressedOops::base() != NULL && ExpandLoadingBaseDecode_NN
#line 5166 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+MEMORY_REF_COST+2 * DEFAULT_COST;
        DFA_PRODUCTION(IREGP, decodeN_NN_Ex_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(INDIRECT, decodeN_NN_Ex_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RODDREGP, decodeN_NN_Ex_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeN_NN_Ex_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 4770 "src/hotspot/cpu/s390/s390.ad"
CompressedOops::base() != NULL && ExpandLoadingBaseDecode
#line 5193 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+MEMORY_REF_COST+3 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeN_Ex_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeN_Ex_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeN_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeN_Ex_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 4743 "src/hotspot/cpu/s390/s390.ad"
false
#line 5258 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeN_base_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeN_base_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeN_base_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 4717 "src/hotspot/cpu/s390/s390.ad"
(n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull ||
             n->bottom_type()->is_oopptr()->ptr() == TypePtr::Constant) &&
            (CompressedOops::base()== NULL || !ExpandLoadingBaseDecode_NN)
#line 5325 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+MEMORY_REF_COST+2 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeN_NN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeN_NN_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeN_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeN_NN_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 4695 "src/hotspot/cpu/s390/s390.ad"
CompressedOops::base() == NULL || !ExpandLoadingBaseDecode
#line 5390 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+MEMORY_REF_COST+3 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeN_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeN_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) &&
        (
#line 4656 "src/hotspot/cpu/s390/s390.ad"
false && (CompressedOops::base()==NULL)&&(CompressedOops::shift()==0)
#line 5455 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeLoadN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeLoadN_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeLoadN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeLoadN_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION(_DECODEN_IREGN_, _DecodeN_iRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        
#line 3387 "src/hotspot/cpu/s390/s390.ad"
CompressedOops::base() == NULL && CompressedOops::shift() == 0 &&
            _leaf->as_DecodeN()->in(0) == NULL
#line 5525 "dfa_s390.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[IREGN]+1;
        DFA_PRODUCTION(IREGN2P, iRegN2P_rule, c)
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+3 * DEFAULT_COST;
        DFA_PRODUCTION(IREGP, decodeKlass_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(INDIRECT, decodeKlass_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(RODDREGP, decodeKlass_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeKlass_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMNKLASS) ) {
      unsigned int c = _kids[0]->_cost[IMMNKLASS]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeLoadConNKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeLoadConNKlass_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeLoadConNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeLoadConNKlass_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADNKLASS_MEMORY_) &&
        (
#line 4667 "src/hotspot/cpu/s390/s390.ad"
false && (CompressedKlassPointers::base()==NULL)&&(CompressedKlassPointers::shift()==0)
#line 5618 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADNKLASS_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeLoadNKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_N2P) || _cost[IREGP_N2P] > c) {
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGP) || _cost[NOARG_IREGP] > c+1) {
        DFA_PRODUCTION(NOARG_IREGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGP) || _cost[RARG1REGP] > c+1) {
        DFA_PRODUCTION(RARG1REGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGP) || _cost[RARG2REGP] > c+1) {
        DFA_PRODUCTION(RARG2REGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGP) || _cost[RARG3REGP] > c+1) {
        DFA_PRODUCTION(RARG3REGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGP) || _cost[RARG4REGP] > c+1) {
        DFA_PRODUCTION(RARG4REGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGP) || _cost[RARG5REGP] > c+1) {
        DFA_PRODUCTION(RARG5REGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYREGP) || _cost[MEMORYREGP] > c+1) {
        DFA_PRODUCTION(MEMORYREGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+1+1) {
        DFA_PRODUCTION(INDIRECT, decodeLoadNKlass_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+1+1) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRXY) || _cost[MEMORYRXY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRX) || _cost[MEMORYRX] > c+1+1) {
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRSY) || _cost[MEMORYRSY] > c+1+1) {
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(MEMORYRS) || _cost[MEMORYRS] > c+1+1) {
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(REVENREGP) || _cost[REVENREGP] > c+1) {
        DFA_PRODUCTION(REVENREGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGP) || _cost[RODDREGP] > c+1) {
        DFA_PRODUCTION(RODDREGP, decodeLoadNKlass_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+1) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeLoadNKlass_rule, c+1)
      }
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORYRX_] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGD, divD_reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, divD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORYRX_] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGF, divF_reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, divF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16]+2 * DEFAULT_COST;
        DFA_PRODUCTION(RODDREGI, divI_reg_imm16_rule, c)
        DFA_PRODUCTION(IREGI, divI_reg_imm16_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, divI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(NOODD_IREGI, divI_reg_imm16_rule, c+1+1+1)
        DFA_PRODUCTION(RARG1REGI, divI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, divI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, divI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, divI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, divI_reg_imm16_rule, c+1+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], NOODD_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[NOODD_IREGI]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c) {
        DFA_PRODUCTION(RODDREGI, divI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c+1) {
        DFA_PRODUCTION(IREGI, divI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+1+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1+1) {
        DFA_PRODUCTION(REVENREGI, divI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, divI_reg_reg_rule, c+1+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1+1) {
        DFA_PRODUCTION(RARG1REGI, divI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1+1) {
        DFA_PRODUCTION(RARG2REGI, divI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1+1) {
        DFA_PRODUCTION(RARG3REGI, divI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1+1) {
        DFA_PRODUCTION(RARG4REGI, divI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1+1) {
        DFA_PRODUCTION(RARG5REGI, divI_reg_reg_rule, c+1+1)
      }
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16]+2 * DEFAULT_COST;
        DFA_PRODUCTION(RODDREGL, divL_reg_imm16_rule, c)
        DFA_PRODUCTION(IREGL, divL_reg_imm16_rule, c+1)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, divL_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(ALLRODDREGL, divL_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGL, divL_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGL, divL_reg_imm16_rule, c+1+1)
    }
    if( STATE__VALID_CHILD(_kids[0], RODDREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[RODDREGL]+_kids[1]->_cost[IREGL]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c) {
        DFA_PRODUCTION(RODDREGL, divL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c+1) {
        DFA_PRODUCTION(IREGL, divL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+1+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+1+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1+1) {
        DFA_PRODUCTION(REVENREGL, divL_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1+1) {
        DFA_PRODUCTION(ALLRODDREGL, divL_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1+1) {
        DFA_PRODUCTION(RARG1REGL, divL_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1+1) {
        DFA_PRODUCTION(RARG5REGL, divL_reg_reg_rule, c+1+1)
      }
    }
}
void  State::_sub_Op_DivModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RODDREGI) && STATE__VALID_CHILD(_kids[1], NOODD_IREGI) ) {
      unsigned int c = _kids[0]->_cost[RODDREGI]+_kids[1]->_cost[NOODD_IREGI]+2 * DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, divModI_reg_divmod_rule, c)
    }
}
void  State::_sub_Op_DivModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RODDREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[RODDREGL]+_kids[1]->_cost[IREGL]+2 * DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, divModL_reg_divmod_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGI) &&
        (
#line 10280 "src/hotspot/cpu/s390/s390.ad"
!((EncodeISOArrayNode*)n)->is_ascii()
#line 5813 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_IREGP_IREGI]+300;
        DFA_PRODUCTION(IREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, encode_iso_array_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, encode_iso_array_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, encode_iso_array_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, encode_iso_array_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, encode_iso_array_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, encode_iso_array_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, encode_iso_array_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, encode_iso_array_rule, c+1)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        (
#line 4889 "src/hotspot/cpu/s390/s390.ad"
(n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull) &&
            (CompressedOops::base_overlaps() && ExpandLoadingBaseEncode_NN)
#line 5834 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+MEMORY_REF_COST+3 * DEFAULT_COST;
        DFA_PRODUCTION(IREGN, encodeP_NN_Ex_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, encodeP_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, encodeP_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, encodeP_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, encodeP_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, encodeP_NN_Ex_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, encodeP_NN_Ex_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        (
#line 4869 "src/hotspot/cpu/s390/s390.ad"
(n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull) &&
            (CompressedOops::base_overlaps() && ExpandLoadingBaseEncode)
#line 5851 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+MEMORY_REF_COST+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, encodeP_Ex_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+1) {
        DFA_PRODUCTION(NOARG_IREGN, encodeP_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+1) {
        DFA_PRODUCTION(RARG1REGN, encodeP_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+1) {
        DFA_PRODUCTION(RARG2REGN, encodeP_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+1) {
        DFA_PRODUCTION(RARG3REGN, encodeP_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+1) {
        DFA_PRODUCTION(RARG4REGN, encodeP_Ex_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+1) {
        DFA_PRODUCTION(RARG5REGN, encodeP_Ex_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 4857 "src/hotspot/cpu/s390/s390.ad"
false
#line 5883 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGL]+MEMORY_REF_COST+2 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, encodeP_NN_base_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+1) {
        DFA_PRODUCTION(NOARG_IREGN, encodeP_NN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+1) {
        DFA_PRODUCTION(RARG1REGN, encodeP_NN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+1) {
        DFA_PRODUCTION(RARG2REGN, encodeP_NN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+1) {
        DFA_PRODUCTION(RARG3REGN, encodeP_NN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+1) {
        DFA_PRODUCTION(RARG4REGN, encodeP_NN_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+1) {
        DFA_PRODUCTION(RARG5REGN, encodeP_NN_base_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGN) &&
        (
#line 4841 "src/hotspot/cpu/s390/s390.ad"
false
#line 5915 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_IREGL_IREGN]+MEMORY_REF_COST+2 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, encodeP_base_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+1) {
        DFA_PRODUCTION(NOARG_IREGN, encodeP_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+1) {
        DFA_PRODUCTION(RARG1REGN, encodeP_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+1) {
        DFA_PRODUCTION(RARG2REGN, encodeP_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+1) {
        DFA_PRODUCTION(RARG3REGN, encodeP_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+1) {
        DFA_PRODUCTION(RARG4REGN, encodeP_base_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+1) {
        DFA_PRODUCTION(RARG5REGN, encodeP_base_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        (
#line 4826 "src/hotspot/cpu/s390/s390.ad"
(n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull) &&
            (CompressedOops::base() == 0 ||
             CompressedOops::base_disjoint() ||
             !ExpandLoadingBaseEncode_NN)
#line 5950 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+MEMORY_REF_COST+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, encodeP_NN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+1) {
        DFA_PRODUCTION(NOARG_IREGN, encodeP_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+1) {
        DFA_PRODUCTION(RARG1REGN, encodeP_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+1) {
        DFA_PRODUCTION(RARG2REGN, encodeP_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+1) {
        DFA_PRODUCTION(RARG3REGN, encodeP_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+1) {
        DFA_PRODUCTION(RARG4REGN, encodeP_NN_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+1) {
        DFA_PRODUCTION(RARG5REGN, encodeP_NN_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        (
#line 4803 "src/hotspot/cpu/s390/s390.ad"
(n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull) &&
            (CompressedOops::base() == 0 ||
             CompressedOops::base_disjoint() ||
             !ExpandLoadingBaseEncode)
#line 5985 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+MEMORY_REF_COST+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, encodeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN_P2N) || _cost[IREGN_P2N] > c) {
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(NOARG_IREGN) || _cost[NOARG_IREGN] > c+1) {
        DFA_PRODUCTION(NOARG_IREGN, encodeP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGN) || _cost[RARG1REGN] > c+1) {
        DFA_PRODUCTION(RARG1REGN, encodeP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGN) || _cost[RARG2REGN] > c+1) {
        DFA_PRODUCTION(RARG2REGN, encodeP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGN) || _cost[RARG3REGN] > c+1) {
        DFA_PRODUCTION(RARG3REGN, encodeP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGN) || _cost[RARG4REGN] > c+1) {
        DFA_PRODUCTION(RARG4REGN, encodeP_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGN) || _cost[RARG5REGN] > c+1) {
        DFA_PRODUCTION(RARG5REGN, encodeP_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        
#line 3379 "src/hotspot/cpu/s390/s390.ad"
CompressedOops::shift() == 0 && _leaf->as_EncodeP()->in(0) == NULL
#line 6017 "dfa_s390.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[IREGP]+1;
        DFA_PRODUCTION(IREGP2N, iRegP2N_rule, c)
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + DEFAULT_COST;
        DFA_PRODUCTION(IREGN, encodeKlass_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, encodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, encodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, encodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, encodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, encodeKlass_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, encodeKlass_rule, c+1)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IREGP_N2P]+100;
        DFA_PRODUCTION(FLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_N2P) && STATE__VALID_CHILD(_kids[1], IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[IREGP_N2P]+_kids[1]->_cost[IREGP_N2P]+100;
        DFA_PRODUCTION(FLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], _BINARY__LOADD_MEMORYRX__REGD) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[_BINARY__LOADD_MEMORYRX__REGD] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGD, msubD_mem_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY__LOADD_MEMORYRX__REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY__LOADD_MEMORYRX__REGD] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, maddD_mem_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD__LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[_BINARY_REGD__LOADD_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, msubD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD__LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD__LOADD_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, maddD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_REGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_REGD_]+_kids[1]->_cost[_BINARY_REGD_REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, msubD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD_REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, maddD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], _BINARY__LOADF_MEMORYRX__REGF) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[_BINARY__LOADF_MEMORYRX__REGF] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGF, msubF_mem_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY__LOADF_MEMORYRX__REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY__LOADF_MEMORYRX__REGF] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, maddF_mem_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF__LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[_BINARY_REGF__LOADF_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, msubF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF__LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF__LOADF_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, maddF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_REGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_REGF_]+_kids[1]->_cost[_BINARY_REGF_REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, msubF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF_REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, maddF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, branchFar_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_HasNegatives(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RARG5REGP) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[RARG5REGP]+_kids[1]->_cost[IREGI]+300;
        DFA_PRODUCTION(IREGI, has_negatives_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, has_negatives_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, has_negatives_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, has_negatives_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, has_negatives_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, has_negatives_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, has_negatives_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, has_negatives_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, has_negatives_rule, c+1)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN___DECODEN_IMMN8_) &&
        (
#line 9536 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6184 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPP__DECODEN_IREGN___DECODEN_IMMN8_]+BRANCH_COST+DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, cmpb_RegN_immN_Far_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN__IMMP0) &&
        (
#line 9523 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6193 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPP__DECODEN_IREGN__IMMP0]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegN_immP0_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IMMP8) &&
        (
#line 9509 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6204 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPP_IREGP_IMMP8]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegP_immP_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML8) &&
        (
#line 9490 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6215 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPL_IREGL_IMML8]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegL_imm_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_UIMMI8) &&
        (
#line 9476 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6226 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPU_IREGI_UIMMI8]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpbU_RegI_imm_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IMMI8) &&
        (
#line 9462 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6237 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPI_IREGI_IMMI8]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegI_imm_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN___DECODEN_IREGN_) &&
        (
#line 9434 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6248 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPP__DECODEN_IREGN___DECODEN_IREGN_]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegNN_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IREGP) &&
        (
#line 9421 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6259 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPP_IREGP_IREGP]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegPP_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) &&
        (
#line 9402 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6270 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPL_IREGL_IREGL]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegL_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) &&
        (
#line 9388 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6281 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPU_IREGI_IREGI]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpbU_RegI_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) &&
        (
#line 9374 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6292 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPI_IREGI_IREGI]+BRANCH_COST+DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, cmpb_RegI_Far_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG]+2 * BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, branchConFar_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_P2N_IMMN0) &&
        (
#line 8241 "src/hotspot/cpu/s390/s390.ad"
TrapBasedNullChecks &&
            _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne &&
            _leaf->as_If ()->_prob >= PROB_LIKELY_MAG(4) &&
            Matcher::branches_to_uncommon_trap(_leaf)
#line 6312 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPN_IREGN_P2N_IMMN0] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, zeroCheckN_iReg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_N2P_IMMP0) &&
        (
#line 8224 "src/hotspot/cpu/s390/s390.ad"
TrapBasedNullChecks &&
            _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne &&
            _leaf->as_If ()->_prob >= PROB_LIKELY_MAG(4) &&
            Matcher::branches_to_uncommon_trap(_leaf)
#line 6326 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPP_IREGP_N2P_IMMP0] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, zeroCheckP_iReg_imm0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_UIMMI16) &&
        (
#line 8206 "src/hotspot/cpu/s390/s390.ad"
TrapBasedRangeChecks &&
            _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt &&
            _leaf->as_If ()->_prob >= PROB_ALWAYS &&
            Matcher::branches_to_uncommon_trap(_leaf)
#line 6340 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPU_IREGI_UIMMI16]+1;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, rangeCheck_uimmI16_iReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) &&
        (
#line 8188 "src/hotspot/cpu/s390/s390.ad"
TrapBasedRangeChecks &&
            _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt &&
            _leaf->as_If ()->_prob >= PROB_ALWAYS &&
            Matcher::branches_to_uncommon_trap(_leaf)
#line 6354 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPU_IREGI_IREGI]+1;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, rangeCheck_iReg_iReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_UIMMI16) &&
        (
#line 8170 "src/hotspot/cpu/s390/s390.ad"
TrapBasedRangeChecks &&
            _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le &&
            PROB_UNLIKELY(_leaf->as_If ()->_prob) >= PROB_ALWAYS &&
            Matcher::branches_to_uncommon_trap(_leaf)
#line 6368 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPT]+_kids[1]->_cost[_CMPU_IREGI_UIMMI16]+1;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, rangeCheck_iReg_uimmI16_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION(_LSHIFTI_IREGI_IMMI_24, _LShiftI_iRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION(_LSHIFTI_IREGI_IMMI_16, _LShiftI_iRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION(_LSHIFTI_IREGI_IMMI8, _LShiftI_iRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 6724 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 6393 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_1] + DEFAULT_COST_LOW;
        DFA_PRODUCTION(IREGI, sllI_reg_imm_1_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, sllI_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, sllI_reg_imm_1_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, sllI_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, sllI_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, sllI_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, sllI_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, sllI_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, sllI_reg_imm_1_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, sllI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, sllI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, sllI_reg_imm_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, sllI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, sllI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, sllI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, sllI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, sllI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, sllI_reg_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, sllI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, sllI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, sllI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, sllI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, sllI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, sllI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, sllI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, sllI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, sllI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION(_LSHIFTL_IREGL_IMMI8, _LShiftL_iRegL_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 6755 "src/hotspot/cpu/s390/s390.ad"
PreferLAoverADD
#line 6483 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_1] + DEFAULT_COST_LOW;
        DFA_PRODUCTION(IREGL, sllL_reg_imm_1_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, sllL_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RODDREGL, sllL_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, sllL_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, sllL_reg_imm_1_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, sllL_reg_imm_1_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, sllL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, sllL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, sllL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, sllL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, sllL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, sllL_reg_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, sllL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, sllL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, sllL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, sllL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, sllL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, sllL_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, loadB_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadB_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, loadB_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, loadB_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, loadB_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, loadB_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, loadB_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, loadB_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, loadB_rule, c+1)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, loadUB_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadUB_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, loadUB_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, loadUB_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, loadUB_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, loadUB_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, loadUB_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, loadUB_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, loadUB_rule, c+1)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, loadUS_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadUS_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, loadUS_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, loadUS_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, loadUS_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, loadUS_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, loadUS_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, loadUS_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, loadUS_rule, c+1)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRX) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRX];
        DFA_PRODUCTION(_LOADD_MEMORYRX_, _LoadD_memoryRX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(REGD, loadD_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_LoadD_unaligned(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(REGD, loadD_unaligned_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRX) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRX];
        DFA_PRODUCTION(_LOADF_MEMORYRX_, _LoadF_memoryRX__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(REGF, loadF_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY];
        DFA_PRODUCTION(_LOADI_MEMORYRSY_, _LoadI_memoryRSY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, loadI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadI_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, loadI_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, loadI_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, loadI_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, loadI_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, loadI_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, loadI_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, loadI_rule, c+1)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGP, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(INDIRECT, loadKlass_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(RODDREGP, loadKlass_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadKlass_rule, c+1)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADNKLASS_MEMORY_, _LoadNKlass_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGN, loadNKlass_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, loadNKlass_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, loadNKlass_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, loadNKlass_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, loadNKlass_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, loadNKlass_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, loadNKlass_rule, c+1)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY];
        DFA_PRODUCTION(_LOADL_MEMORYRSY_, _LoadL_memoryRSY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGL, loadL_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, loadL_rule, c+1)
        DFA_PRODUCTION(RODDREGL, loadL_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, loadL_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, loadL_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, loadL_rule, c+1)
    }
}
void  State::_sub_Op_LoadL_unaligned(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, loadL_unaligned_rule, c+1)
        DFA_PRODUCTION(RODDREGL, loadL_unaligned_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, loadL_unaligned_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, loadL_unaligned_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, loadL_unaligned_rule, c+1)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGP, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(INDIRECT, loadPLocked_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(RODDREGP, loadPLocked_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadPLocked_rule, c+1)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY];
        DFA_PRODUCTION(_LOADP_MEMORYRSY_, _LoadP_memoryRSY__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADP_MEMORY_, _LoadP_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGP, loadP_rule, c)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, loadP_rule, c+1)
        DFA_PRODUCTION(RARG1REGP, loadP_rule, c+1)
        DFA_PRODUCTION(RARG2REGP, loadP_rule, c+1)
        DFA_PRODUCTION(RARG3REGP, loadP_rule, c+1)
        DFA_PRODUCTION(RARG4REGP, loadP_rule, c+1)
        DFA_PRODUCTION(RARG5REGP, loadP_rule, c+1)
        DFA_PRODUCTION(MEMORYREGP, loadP_rule, c+1)
        DFA_PRODUCTION(INDIRECT, loadP_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
        DFA_PRODUCTION(REVENREGP, loadP_rule, c+1)
        DFA_PRODUCTION(RODDREGP, loadP_rule, c+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadP_rule, c+1)
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADN_MEMORY_, _LoadN_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGN, loadN_rule, c)
        DFA_PRODUCTION(IREGN_P2N, iRegN_rule, c)
        DFA_PRODUCTION(NOARG_IREGN, loadN_rule, c+1)
        DFA_PRODUCTION(RARG1REGN, loadN_rule, c+1)
        DFA_PRODUCTION(RARG2REGN, loadN_rule, c+1)
        DFA_PRODUCTION(RARG3REGN, loadN_rule, c+1)
        DFA_PRODUCTION(RARG4REGN, loadN_rule, c+1)
        DFA_PRODUCTION(RARG5REGN, loadN_rule, c+1)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, loadRange_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadRange_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, loadRange_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, loadRange_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, loadRange_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, loadRange_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, loadRange_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, loadRange_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, loadRange_rule, c+1)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, loadS_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, loadS_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, loadS_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, loadS_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, loadS_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, loadS_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, loadS_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, loadS_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, loadS_rule, c+1)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8883 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 6837 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI8]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGI, z10_maxI_reg_imm8_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, z10_maxI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, z10_maxI_reg_imm8_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, z10_maxI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, z10_maxI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, z10_maxI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, z10_maxI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, z10_maxI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, z10_maxI_reg_imm8_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, maxI_reg_imm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, maxI_reg_imm16_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, maxI_reg_imm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 8840 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadStoreConditional()
#line 6888 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z196_maxI_reg_imm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z196_maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z196_maxI_reg_imm16_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z196_maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z196_maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z196_maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z196_maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z196_maxI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z196_maxI_reg_imm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, maxI_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, maxI_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, maxI_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 8796 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadStoreConditional()
#line 6959 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z196_maxI_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z196_maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z196_maxI_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z196_maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z196_maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z196_maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z196_maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z196_maxI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z196_maxI_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8758 "src/hotspot/cpu/s390/s390.ad"
!VM_Version::has_CompareBranch()
#line 6997 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, maxI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, maxI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, maxI_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8725 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 7035 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z10_maxI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z10_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z10_maxI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z10_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z10_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z10_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z10_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z10_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z10_maxI_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8693 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadStoreConditional()
#line 7073 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z196_maxI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z196_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z196_maxI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z196_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z196_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z196_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z196_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z196_maxI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z196_maxI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 4*MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 4*MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_0_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarCPUOrder(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_CPUOrder_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 4 * MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 4 * MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, membar_release_0_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 5032 "src/hotspot/cpu/s390/s390.ad"
Matcher::post_store_load_barrier(n)
#line 7154 "dfa_s390.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 4 * MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8673 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 7177 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI8]+DEFAULT_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGI, z10_minI_reg_imm8_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, z10_minI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, z10_minI_reg_imm8_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, z10_minI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, z10_minI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, z10_minI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, z10_minI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, z10_minI_reg_imm8_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, z10_minI_reg_imm8_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, minI_reg_imm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, minI_reg_imm16_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, minI_reg_imm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 8629 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadStoreConditional()
#line 7228 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z196_minI_reg_imm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z196_minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z196_minI_reg_imm16_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z196_minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z196_minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z196_minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z196_minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z196_minI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z196_minI_reg_imm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, minI_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, minI_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, minI_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 8585 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadStoreConditional()
#line 7299 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z196_minI_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z196_minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z196_minI_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z196_minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z196_minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z196_minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z196_minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z196_minI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z196_minI_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8549 "src/hotspot/cpu/s390/s390.ad"
!VM_Version::has_CompareBranch()
#line 7337 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, minI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, minI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, minI_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8516 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_CompareBranch()
#line 7375 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z10_minI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z10_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z10_minI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z10_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z10_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z10_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z10_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z10_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z10_minI_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8483 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_LoadStoreConditional()
#line 7413 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, z196_minI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, z196_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, z196_minI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, z196_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, z196_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, z196_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, z196_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, z196_minI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, z196_minI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16]+3 * DEFAULT_COST;
        DFA_PRODUCTION(REVENREGI, modI_reg_imm16_rule, c)
        DFA_PRODUCTION(IREGI, modI_reg_imm16_rule, c+1)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGI, modI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGI, modI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGI, modI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGI, modI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGI, modI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGI, modI_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(NOODD_IREGI, modI_reg_imm16_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], NOODD_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[NOODD_IREGI]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c) {
        DFA_PRODUCTION(REVENREGI, modI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c+1) {
        DFA_PRODUCTION(IREGI, modI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+1+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+1+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1+1) {
        DFA_PRODUCTION(RODDREGI, modI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1+1) {
        DFA_PRODUCTION(RARG1REGI, modI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1+1) {
        DFA_PRODUCTION(RARG2REGI, modI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1+1) {
        DFA_PRODUCTION(RARG3REGI, modI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1+1) {
        DFA_PRODUCTION(RARG4REGI, modI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1+1) {
        DFA_PRODUCTION(RARG5REGI, modI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1) {
        DFA_PRODUCTION(NOODD_IREGI, modI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16]+3 * DEFAULT_COST;
        DFA_PRODUCTION(REVENREGL, modL_reg_imm16_rule, c)
        DFA_PRODUCTION(IREGL, modL_reg_imm16_rule, c+1)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGL, modL_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(ALLRODDREGL, modL_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGL, modL_reg_imm16_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGL, modL_reg_imm16_rule, c+1+1)
    }
    if( STATE__VALID_CHILD(_kids[0], RODDREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[RODDREGL]+_kids[1]->_cost[IREGL]+2 * DEFAULT_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c) {
        DFA_PRODUCTION(REVENREGL, modL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c+1) {
        DFA_PRODUCTION(IREGL, modL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+1+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+1+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1+1) {
        DFA_PRODUCTION(RODDREGL, modL_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1+1) {
        DFA_PRODUCTION(ALLRODDREGL, modL_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1+1) {
        DFA_PRODUCTION(RARG1REGL, modL_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1+1) {
        DFA_PRODUCTION(RARG5REGL, modL_reg_reg_rule, c+1+1)
      }
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + MEMORY_REF_COST;
        DFA_PRODUCTION(STACKSLOTF, MoveI2F_reg_stack_rule, c)
        DFA_PRODUCTION(REGF, stkF_to_regF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, MoveI2F_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, MoveF2I_stack_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, MoveF2I_stack_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, MoveF2I_stack_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, MoveF2I_stack_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, MoveF2I_stack_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, MoveF2I_stack_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, MoveF2I_stack_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, MoveF2I_stack_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, MoveF2I_stack_reg_rule, c+1)
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + MEMORY_REF_COST;
        DFA_PRODUCTION(STACKSLOTD, MoveL2D_reg_stack_rule, c)
        DFA_PRODUCTION(REGD, stkD_to_regD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, MoveL2D_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD] + MEMORY_REF_COST;
        DFA_PRODUCTION(STACKSLOTL, MoveD2L_reg_stack_rule, c)
        DFA_PRODUCTION(IREGL, stkL_to_regL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, stkL_to_regL_rule, c+MEMORY_REF_COST+1)
        DFA_PRODUCTION(RODDREGL, stkL_to_regL_rule, c+MEMORY_REF_COST+1)
        DFA_PRODUCTION(ALLRODDREGL, stkL_to_regL_rule, c+MEMORY_REF_COST+1)
        DFA_PRODUCTION(RARG1REGL, stkL_to_regL_rule, c+MEMORY_REF_COST+1)
        DFA_PRODUCTION(RARG5REGL, stkL_to_regL_rule, c+MEMORY_REF_COST+1)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, MoveD2L_stack_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, MoveD2L_stack_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, MoveD2L_stack_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, MoveD2L_stack_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, MoveD2L_stack_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORYRX_) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORYRX_]+_kids[1]->_cost[REGD] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGD, mulD_reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, mulD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, mulD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORYRX_) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORYRX_]+_kids[1]->_cost[REGF] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGF, mulF_reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORYRX_] + ALU_MEMORY_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, mulF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, mulF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RODDREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[RODDREGL]+_kids[1]->_cost[IREGL]+7*DEFAULT_COST;
        DFA_PRODUCTION(REVENREGL, mulHiL_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL, mulHiL_reg_reg_rule, c+1)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(RODDREGL, mulHiL_reg_reg_rule, c+1+1)
        DFA_PRODUCTION(ALLRODDREGL, mulHiL_reg_reg_rule, c+1+1)
        DFA_PRODUCTION(RARG1REGL, mulHiL_reg_reg_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGL, mulHiL_reg_reg_rule, c+1+1)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGI, mulI_Reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, mulI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, mulI_Reg_mem_0_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, mulI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, mulI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, mulI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, mulI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, mulI_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, mulI_Reg_mem_0_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, mulI_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, mulI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, mulI_Reg_mem_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, mulI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, mulI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, mulI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, mulI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, mulI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, mulI_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, mulI_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, mulI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, mulI_reg_imm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, mulI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, mulI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, mulI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, mulI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, mulI_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, mulI_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, mulI_reg_imm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, mulI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, mulI_reg_imm16_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, mulI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, mulI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, mulI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, mulI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, mulI_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, mulI_reg_imm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, mulI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, mulI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, mulI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, mulI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, mulI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, mulI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, mulI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, mulI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, mulI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGL, mulL_Reg_mem_0_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, mulL_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RODDREGL, mulL_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, mulL_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, mulL_Reg_mem_0_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, mulL_Reg_mem_0_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_Reg_memI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_Reg_memI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_Reg_memI_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L__LOADI_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L__LOADI_MEMORY__] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_Reg_memI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_Reg_memI_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML32] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_reg_imm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_reg_imm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_reg_imm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_reg_imm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_reg_imm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_reg_imm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_reg_regI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_reg_regI_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_reg_regI_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L_IREGI_] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, mulL_reg_regI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, mulL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, mulL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, mulL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, mulL_reg_regI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, mulL_reg_regI_rule, c+1)
      }
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD] + DEFAULT_COST;
        DFA_PRODUCTION(REGD, negD_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], _ABSD_REGD_) ) {
      unsigned int c = _kids[0]->_cost[_ABSD_REGD_] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, nabsD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION(_NEGD_REGD_, _NegD_regD__rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF] + DEFAULT_COST;
        DFA_PRODUCTION(REGF, negF_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], _ABSF_REGF_) ) {
      unsigned int c = _kids[0]->_cost[_ABSF_REGF_] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, nabsF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(_NEGF_REGF_, _NegF_regF__rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMML32] + DEFAULT_COST_HIGH;
        DFA_PRODUCTION(IREGI, orL_reg_uimm32_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, orL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, orL_reg_uimm32_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, orL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, orL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, orL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, orL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, orL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, orL_reg_uimm32_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI] + DEFAULT_COST_HIGH;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_reg_uimm32_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, orI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, orI_reg_uimm32_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, orI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, orI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, orI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, orI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, orI_reg_uimm32_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, orI_reg_uimm32_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI16) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_reg_uimm16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, orI_reg_uimm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, orI_reg_uimm16_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, orI_reg_uimm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, orI_reg_uimm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, orI_reg_uimm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, orI_reg_uimm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, orI_reg_uimm16_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, orI_reg_uimm16_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, orI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, orI_Reg_mem_0_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, orI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, orI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, orI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, orI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, orI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, orI_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, orI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, orI_Reg_mem_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, orI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, orI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, orI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, orI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, orI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, orI_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, orI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, orI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, orI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, orI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, orI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, orI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, orI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, orI_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGI_IMMI8) &&
        (
#line 6883 "src/hotspot/cpu/s390/s390.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 8251 "dfa_s390.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGI_IMMI8]+_kids[1]->_cost[_LSHIFTI_IREGI_IMMI8] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, rotlI_reg_immI8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, rotlI_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, rotlI_reg_immI8_0_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, rotlI_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, rotlI_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, rotlI_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, rotlI_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, rotlI_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, rotlI_reg_immI8_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGI_IMMI8) &&
        (
#line 6883 "src/hotspot/cpu/s390/s390.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 8289 "dfa_s390.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI_IMMI8]+_kids[1]->_cost[_URSHIFTI_IREGI_IMMI8] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, rotlI_reg_immI8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, rotlI_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, rotlI_reg_immI8_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, rotlI_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, rotlI_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, rotlI_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, rotlI_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, rotlI_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, rotlI_reg_immI8_rule, c+1)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML16) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML16] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, orL_reg_uimm16_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, orL_reg_uimm16_rule, c+1)
        DFA_PRODUCTION(RODDREGL, orL_reg_uimm16_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, orL_reg_uimm16_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, orL_reg_uimm16_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, orL_reg_uimm16_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, orL_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, orL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, orL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, orL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, orL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, orL_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, orL_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, orL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, orL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, orL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, orL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, orL_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, orL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, orL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, orL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, orL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, orL_reg_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI8) &&
        (
#line 6894 "src/hotspot/cpu/s390/s390.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 8411 "dfa_s390.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI8]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI8] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, rotlL_reg_immI8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, rotlL_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, rotlL_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, rotlL_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, rotlL_reg_immI8_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, rotlL_reg_immI8_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI8) &&
        (
#line 6894 "src/hotspot/cpu/s390/s390.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 8440 "dfa_s390.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI8]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI8] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, rotlL_reg_immI8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, rotlL_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, rotlL_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, rotlL_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, rotlL_reg_immI8_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, rotlL_reg_immI8_rule, c+1)
      }
    }
}
void  State::_sub_Op_OverflowAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, overflowAddI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, overflowAddI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, overflowNegI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, overflowSubI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, overflowSubI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, overflowAddL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, overflowAddL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML_0) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_0]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, overflowNegL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, overflowSubL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(FLAGSREG) || _cost[FLAGSREG] > c) {
        DFA_PRODUCTION(FLAGSREG, overflowSubL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RARG2REGP) && STATE__VALID_CHILD(_kids[1], RARG3REGP) ) {
      unsigned int c = _kids[0]->_cost[RARG2REGP]+_kids[1]->_cost[RARG3REGP];
        DFA_PRODUCTION(_PARTIALSUBTYPECHECK_RARG2REGP_RARG3REGP, _PartialSubtypeCheck_rarg2RegP_rarg3RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RARG2REGP) && STATE__VALID_CHILD(_kids[1], RARG3REGP) ) {
      unsigned int c = _kids[0]->_cost[RARG2REGP]+_kids[1]->_cost[RARG3REGP]+10 * DEFAULT_COST;
        DFA_PRODUCTION(RARG1REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION(IREGP, partialSubtypeCheck_rule, c+1)
        DFA_PRODUCTION(STACKSLOTP, regP_to_stkP_rule, c+1+MEMORY_REF_COST)
        DFA_PRODUCTION(NOARG_IREGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(RARG2REGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(RARG3REGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(RARG4REGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(RARG5REGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(MEMORYREGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(INDIRECT, partialSubtypeCheck_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1+1)
        DFA_PRODUCTION(REVENREGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(RODDREGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(INLINE_CACHE_REGP, partialSubtypeCheck_rule, c+1+1)
        DFA_PRODUCTION(IREGP_N2P, iRegP_rule, c+1)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 10907 "src/hotspot/cpu/s390/s390.ad"
UsePopCountInstruction && VM_Version::has_PopCount()
#line 8559 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, popCountI_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, popCountI_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, popCountI_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, popCountI_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, popCountI_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, popCountI_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, popCountI_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, popCountI_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, popCountI_rule, c+1)
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 10934 "src/hotspot/cpu/s390/s390.ad"
UsePopCountInstruction && VM_Version::has_PopCount()
#line 8579 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, popCountL_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, popCountL_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, popCountL_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, popCountL_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, popCountL_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, popCountL_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, popCountL_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, popCountL_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, popCountL_rule, c+1)
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 4502 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_Prefetch()
#line 8599 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, prefetchAlloc_rule, c)
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*amount*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI_IMMI_24]+_kids[1]->_cost[IMMI_24] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, rShiftI24_lShiftI24_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, rShiftI24_lShiftI24_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, rShiftI24_lShiftI24_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, rShiftI24_lShiftI24_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, rShiftI24_lShiftI24_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, rShiftI24_lShiftI24_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, rShiftI24_lShiftI24_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, rShiftI24_lShiftI24_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, rShiftI24_lShiftI24_reg_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*amount*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI_IMMI_16]+_kids[1]->_cost[IMMI_16] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, rShiftI16_lShiftI16_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, rShiftI16_lShiftI16_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, rShiftI16_lShiftI16_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, sraI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, sraI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, sraI_reg_imm_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, sraI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, sraI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, sraI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, sraI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, sraI_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, sraI_reg_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, sraI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, sraI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, sraI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, sraI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, sraI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, sraI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, sraI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, sraI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, sraI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION(_RSHIFTL_IREGL_IMMI_32_63, _RShiftL_iRegL_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, sraL_reg_imm_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, sraL_reg_imm_rule, c+1)
        DFA_PRODUCTION(RODDREGL, sraL_reg_imm_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, sraL_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, sraL_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, sraL_reg_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, sraL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, sraL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, sraL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, sraL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, sraL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, sraL_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION(REGD, roundDouble_nop_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION(REGF, roundFloat_nop_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, safePoint_poll_rule, c)
    }
    if(         (
#line 9600 "src/hotspot/cpu/s390/s390.ad"
false
#line 8795 "dfa_s390.cpp"
) ) {
      unsigned int c = DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, safePoint_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRX) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRX] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGD, sqrtD_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_MEMORYRX_];
        DFA_PRODUCTION(_SQRTD__CONVF2D_MEMORYRX__, _SqrtD__ConvF2D_memoryRX___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, sqrtD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_REGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_REGF_];
        DFA_PRODUCTION(_SQRTD__CONVF2D_REGF__, _SqrtD__ConvF2D_regF___rule, c)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[IMMI8] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, memInitB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRS) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRS]+_kids[1]->_cost[IMMI16] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, memInitC_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI_0] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, storeCM_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_RARG5REGP_IREGP_N2P) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_RARG5REGP_IREGP_N2P] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_RARG5REGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_RARG5REGL_IREGL] + DEFAULT_COST;
        DFA_PRODUCTION(FLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, storeD_rule, c)
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, storeF_rule, c)
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORYRSY__IMMI8) &&
        (
#line 5824 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_MemWithImmALUOps()
#line 8886 "dfa_s390.cpp"
) && /*mem*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[_ADDI__LOADI_MEMORYRSY__IMMI8] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, addI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRS) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRS]+_kids[1]->_cost[IMMI16] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, memInitI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORYRSY__IMML8) &&
        (
#line 5983 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_MemWithImmALUOps()
#line 8909 "dfa_s390.cpp"
) && /*mem*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[_ADDL__LOADL_MEMORYRSY__IMML8] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, addL_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRS) && STATE__VALID_CHILD(_kids[1], IMML16) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRS]+_kids[1]->_cost[IMML16] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, memInitL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORYRSY) && STATE__VALID_CHILD(_kids[1], _ADDP__LOADP_MEMORYRSY__IMML8) &&
        (
#line 6149 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_MemWithImmALUOps()
#line 8932 "dfa_s390.cpp"
) && /*mem*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRSY]+_kids[1]->_cost[_ADDP__LOADP_MEMORYRSY__IMML8] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, addP_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORYRS) && STATE__VALID_CHILD(_kids[1], IMMP16) ) {
      unsigned int c = _kids[0]->_cost[MEMORYRS]+_kids[1]->_cost[IMMP16] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, memInitP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORYREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORYREGP] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN_P2N) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN_P2N] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, storeN_rule, c)
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, storeNKlass_rule, c)
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 10018 "src/hotspot/cpu/s390/s390.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UL
#line 8967 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
        DFA_PRODUCTION(IREGI, string_compareUL_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, string_compareUL_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, string_compareUL_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, string_compareUL_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, string_compareUL_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, string_compareUL_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, string_compareUL_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, string_compareUL_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, string_compareUL_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 10003 "src/hotspot/cpu/s390/s390.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LU
#line 8985 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, string_compareLU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, string_compareLU_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, string_compareLU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, string_compareLU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, string_compareLU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, string_compareLU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, string_compareLU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, string_compareLU_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 9988 "src/hotspot/cpu/s390/s390.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UU || ((StrCompNode*)n)->encoding() == StrIntrinsicNode::none
#line 9023 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, string_compareU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, string_compareU_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, string_compareU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, string_compareU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, string_compareU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, string_compareU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, string_compareU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, string_compareU_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 9973 "src/hotspot/cpu/s390/s390.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LL
#line 9061 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, string_compareL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, string_compareL_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, string_compareL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, string_compareL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, string_compareL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, string_compareL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, string_compareL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, string_compareL_rule, c+1)
      }
    }
}
void  State::_sub_Op_StrCompressedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_IREGP_IREGI]+300;
        DFA_PRODUCTION(IREGI, string_compress_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, string_compress_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, string_compress_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, string_compress_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, string_compress_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, string_compress_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, string_compress_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, string_compress_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, string_compress_rule, c+1)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGP) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9918 "src/hotspot/cpu/s390/s390.ad"
((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::none
#line 9116 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGP]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION(IREGI, string_equalsC_imm_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, string_equalsC_imm_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, string_equalsC_imm_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, string_equalsC_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, string_equalsC_imm_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, string_equalsC_imm_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, string_equalsC_imm_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, string_equalsC_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, string_equalsC_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGP) && STATE__VALID_CHILD(_kids[1], UIMMI8) &&
        (
#line 9893 "src/hotspot/cpu/s390/s390.ad"
((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::LL || ((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::UU
#line 9134 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGP]+_kids[1]->_cost[UIMMI8]+100;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, string_equals_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, string_equals_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, string_equals_imm_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, string_equals_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, string_equals_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, string_equals_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, string_equals_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, string_equals_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, string_equals_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGP) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 9879 "src/hotspot/cpu/s390/s390.ad"
((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::UU || ((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::none
#line 9172 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGP]+_kids[1]->_cost[IREGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, string_equalsU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, string_equalsU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, string_equalsU_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, string_equalsU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, string_equalsU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, string_equalsU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, string_equalsU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, string_equalsU_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, string_equalsU_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGP) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 9865 "src/hotspot/cpu/s390/s390.ad"
((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::LL
#line 9210 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGP]+_kids[1]->_cost[IREGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, string_equalsL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, string_equalsL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, string_equalsL_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, string_equalsL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, string_equalsL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, string_equalsL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, string_equalsL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, string_equalsL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, string_equalsL_rule, c+1)
      }
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 10203 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 9250 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
        DFA_PRODUCTION(IREGI, indexOf_UL_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, indexOf_UL_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, indexOf_UL_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, indexOf_UL_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, indexOf_UL_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, indexOf_UL_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, indexOf_UL_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, indexOf_UL_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, indexOf_UL_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 10188 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 9268 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_L_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_RARG5REGI) &&
        (
#line 10173 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU || ((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::none
#line 9306 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_RARG5REGI]+300;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_U_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_U_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_U_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMI16) &&
        (
#line 10158 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 9344 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_IMMI16]+250;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_imm_UL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_imm_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_imm_UL_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_imm_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_imm_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_imm_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_imm_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_imm_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_imm_UL_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMI16) &&
        (
#line 10143 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 9382 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_IMMI16]+250;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_imm_L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_imm_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_imm_L_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_imm_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_imm_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_imm_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_imm_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_imm_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_imm_L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_RARG2REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMI16) &&
        (
#line 10128 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU || ((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::none
#line 9420 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_RARG2REGI]+_kids[1]->_cost[_BINARY_IREGP_IMMI16]+250;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_imm_U_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_imm_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_imm_U_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_imm_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_imm_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_imm_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_imm_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_imm_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_imm_U_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMP_IMMI_1) &&
        (
#line 10108 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 9458 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGI]+_kids[1]->_cost[_BINARY_IMMP_IMMI_1]+200;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_imm1_UL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_imm1_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_imm1_UL_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_imm1_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_imm1_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_imm1_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_imm1_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_imm1_UL_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_imm1_UL_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMP_IMMI_1) &&
        (
#line 10089 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 9496 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGI]+_kids[1]->_cost[_BINARY_IMMP_IMMI_1]+200;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_imm1_L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_imm1_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_imm1_L_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_imm1_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_imm1_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_imm1_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_imm1_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_imm1_L_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_imm1_L_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMP_IMMI_1) &&
        (
#line 10064 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU || ((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::none
#line 9534 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGI]+_kids[1]->_cost[_BINARY_IMMP_IMMI_1]+200;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOf_imm1_U_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOf_imm1_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOf_imm1_U_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOf_imm1_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOf_imm1_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOf_imm1_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOf_imm1_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOf_imm1_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOf_imm1_U_rule, c+1)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 10049 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::L
#line 9574 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGI]+_kids[1]->_cost[IREGI]+200;
        DFA_PRODUCTION(IREGI, indexOfChar_L_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, indexOfChar_L_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, indexOfChar_L_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, indexOfChar_L_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, indexOfChar_L_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, indexOfChar_L_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, indexOfChar_L_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, indexOfChar_L_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, indexOfChar_L_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 10034 "src/hotspot/cpu/s390/s390.ad"
((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::U
#line 9592 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_IREGI]+_kids[1]->_cost[IREGI]+200;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, indexOfChar_U_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, indexOfChar_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, indexOfChar_U_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, indexOfChar_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, indexOfChar_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, indexOfChar_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, indexOfChar_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, indexOfChar_U_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, indexOfChar_U_rule, c+1)
      }
    }
}
void  State::_sub_Op_StrInflatedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_IREGP_IMMI]+300;
        DFA_PRODUCTION(UNIVERSE, string_inflate_const_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_BINARY_IREGP_IREGI]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, string_inflate_rule, c)
      }
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORYRX_] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGD, subD_reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION(REGD, subD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTD, regD_to_stkD_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORYRX_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORYRX_] + ALU_MEMORY_COST;
        DFA_PRODUCTION(REGF, subF_reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF] + ALU_REG_COST;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION(REGF, subF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTF, regF_to_stkF_rule, c+MEMORY_REF_COST)
      }
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) && STATE__VALID_CHILD(_kids[1], _ABSI_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+_kids[1]->_cost[_ABSI_IREGI_] + DEFAULT_COST_LOW;
        DFA_PRODUCTION(IREGI, negabsI_reg_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, negabsI_reg_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, negabsI_reg_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, negabsI_reg_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, negabsI_reg_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, negabsI_reg_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, negabsI_reg_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, negabsI_reg_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, negabsI_reg_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, subI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, subI_zero_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, subI_zero_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, subI_zero_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, subI_zero_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, subI_zero_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, subI_zero_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, subI_zero_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, subI_zero_reg_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, subI_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, subI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, subI_Reg_mem_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, subI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, subI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, subI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, subI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, subI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, subI_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 6174 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_DistinctOpnds()
#line 9755 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, subI_reg_reg_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, subI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, subI_reg_reg_RISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, subI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, subI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, subI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, subI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, subI_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, subI_reg_reg_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, subI_reg_reg_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, subI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, subI_reg_reg_CISC_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, subI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, subI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, subI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, subI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, subI_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, subI_reg_reg_CISC_rule, c+1)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGL, subL_Reg_mem_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, subL_Reg_mem_rule, c+1)
        DFA_PRODUCTION(RODDREGL, subL_Reg_mem_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, subL_Reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, subL_Reg_mem_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, subL_Reg_mem_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L__LOADI_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L__LOADI_MEMORY__] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, subL_Reg_memI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, subL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, subL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, subL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, subL_Reg_memI_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, subL_Reg_memI_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L_IREGI_] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, subL_reg_regI_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, subL_reg_regI_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, subL_reg_regI_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, subL_reg_regI_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, subL_reg_regI_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, subL_reg_regI_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6220 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_DistinctOpnds()
#line 9886 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, subL_reg_reg_RISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, subL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, subL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, subL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, subL_reg_reg_RISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, subL_reg_reg_RISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, subL_reg_reg_CISC_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, subL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, subL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, subL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, subL_reg_reg_CISC_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, subL_reg_reg_CISC_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_0) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_0]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, negL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, negL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, negL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, negL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, negL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, negL_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], INLINE_CACHE_REGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[INLINE_CACHE_REGP] + CALL_COST;
        DFA_PRODUCTION(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], RARG1REGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[RARG1REGP] + CALL_COST;
        DFA_PRODUCTION(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(THREADREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(MEMORYREGP, tlsLoadP_rule, c+1)
        DFA_PRODUCTION(INDIRECT, tlsLoadP_rule, c+1+1)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRXY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRX, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRSY, indirect_rule, c+1+1)
        DFA_PRODUCTION(MEMORYRS, indirect_rule, c+1+1)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION(_URSHIFTI_IREGI_IMMI8, _URShiftI_iRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI, srlI_reg_imm_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, srlI_reg_imm_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, srlI_reg_imm_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, srlI_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, srlI_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, srlI_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, srlI_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, srlI_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, srlI_reg_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+3 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, srlI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, srlI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, srlI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, srlI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, srlI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, srlI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, srlI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, srlI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, srlI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION(_URSHIFTL_IREGL_IMMI8, _URShiftL_iRegL_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_N2P_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_N2P_]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, srlP_reg_imm_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, srlP_reg_imm_rule, c+1)
        DFA_PRODUCTION(RODDREGL, srlP_reg_imm_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, srlP_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, srlP_reg_imm_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, srlP_reg_imm_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, srlL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, srlL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, srlL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, srlL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, srlL_reg_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, srlL_reg_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, srlL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, srlL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, srlL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, srlL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, srlL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, srlL_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], UIMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[UIMMI] + DEFAULT_COST_HIGH;
        DFA_PRODUCTION(IREGI, xorI_reg_uimm32_rule, c)
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGI, xorI_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(NOODD_IREGI, xorI_reg_uimm32_rule, c+1+1)
        DFA_PRODUCTION(RODDREGI, xorI_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG1REGI, xorI_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG2REGI, xorI_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG3REGI, xorI_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG4REGI, xorI_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG5REGI, xorI_reg_uimm32_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IREGI] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, xorI_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, xorI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, xorI_Reg_mem_0_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, xorI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, xorI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, xorI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, xorI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, xorI_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, xorI_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_LOADI_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, xorI_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, xorI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, xorI_Reg_mem_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, xorI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, xorI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, xorI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, xorI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, xorI_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, xorI_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTI, regI_to_stkI_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGI) || _cost[REVENREGI] > c+1) {
        DFA_PRODUCTION(REVENREGI, xorI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(NOODD_IREGI) || _cost[NOODD_IREGI] > c+1+1) {
        DFA_PRODUCTION(NOODD_IREGI, xorI_reg_reg_rule, c+1+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGI) || _cost[RODDREGI] > c+1) {
        DFA_PRODUCTION(RODDREGI, xorI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGI) || _cost[RARG1REGI] > c+1) {
        DFA_PRODUCTION(RARG1REGI, xorI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG2REGI) || _cost[RARG2REGI] > c+1) {
        DFA_PRODUCTION(RARG2REGI, xorI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG3REGI) || _cost[RARG3REGI] > c+1) {
        DFA_PRODUCTION(RARG3REGI, xorI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG4REGI) || _cost[RARG4REGI] > c+1) {
        DFA_PRODUCTION(RARG4REGI, xorI_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGI) || _cost[RARG5REGI] > c+1) {
        DFA_PRODUCTION(RARG5REGI, xorI_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], UIMML32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[UIMML32] + DEFAULT_COST_HIGH;
        DFA_PRODUCTION(IREGL, xorL_reg_uimm32_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, xorL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RODDREGL, xorL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, xorL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, xorL_reg_uimm32_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, xorL_reg_uimm32_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, xorL_Reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, xorL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, xorL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, xorL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, xorL_Reg_mem_0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, xorL_Reg_mem_0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LOADL_MEMORY_] + MEMORY_REF_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, xorL_Reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, xorL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, xorL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, xorL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, xorL_Reg_mem_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, xorL_Reg_mem_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, xorL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, xorL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, xorL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, xorL_reg_reg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, xorL_reg_reg_rule, c+1)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 10704 "src/hotspot/cpu/s390/s390.ad"
n->as_LoadVector()->memory_size() == 8
#line 10304 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION(IREGL, loadV8_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, loadV8_rule, c+1)
        DFA_PRODUCTION(RODDREGL, loadV8_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, loadV8_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, loadV8_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, loadV8_rule, c+1)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 10693 "src/hotspot/cpu/s390/s390.ad"
n->as_StoreVector()->memory_size() == 8
#line 10321 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGL] + MEMORY_REF_COST;
        DFA_PRODUCTION(UNIVERSE, storeA8B_rule, c)
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMB_MINUS1) &&
        (
#line 10512 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 8
#line 10332 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMB_MINUS1] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, Repl8B_immm1_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, Repl8B_immm1_rule, c+1)
        DFA_PRODUCTION(RODDREGL, Repl8B_immm1_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, Repl8B_immm1_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, Repl8B_immm1_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, Repl8B_immm1_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 10502 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 8
#line 10347 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl8B_imm0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl8B_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl8B_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl8B_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl8B_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl8B_imm0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMB_N0M1) &&
        (
#line 10484 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 8
#line 10376 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMB_N0M1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl8B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl8B_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl8B_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl8B_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl8B_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl8B_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 10468 "src/hotspot/cpu/s390/s390.ad"
(n->as_Vector()->length() == 8)
#line 10405 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl8B_reg_risbg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl8B_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl8B_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl8B_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl8B_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl8B_reg_risbg_rule, c+1)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMS_MINUS1) &&
        (
#line 10567 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 4
#line 10436 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMS_MINUS1] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, Repl4S_immm1_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, Repl4S_immm1_rule, c+1)
        DFA_PRODUCTION(RODDREGL, Repl4S_immm1_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, Repl4S_immm1_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, Repl4S_immm1_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, Repl4S_immm1_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 10557 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 4
#line 10451 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl4S_imm0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl4S_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl4S_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl4S_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl4S_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl4S_imm0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMS_N0M1) &&
        (
#line 10539 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 4
#line 10480 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMS_N0M1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl4S_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl4S_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl4S_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl4S_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl4S_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 10524 "src/hotspot/cpu/s390/s390.ad"
(n->as_Vector()->length() == 4)
#line 10509 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl4S_reg_risbg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl4S_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl4S_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl4S_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl4S_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl4S_reg_risbg_rule, c+1)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_MINUS1) &&
        (
#line 10619 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 2
#line 10540 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_MINUS1] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, Repl2I_immm1_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, Repl2I_immm1_rule, c+1)
        DFA_PRODUCTION(RODDREGL, Repl2I_immm1_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, Repl2I_immm1_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, Repl2I_immm1_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, Repl2I_immm1_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 10609 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 2
#line 10555 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl2I_imm0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl2I_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl2I_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl2I_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl2I_imm0_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl2I_imm0_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_N0M1) &&
        (
#line 10593 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 2
#line 10584 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_N0M1] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl2I_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl2I_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl2I_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl2I_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl2I_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 10579 "src/hotspot/cpu/s390/s390.ad"
(n->as_Vector()->length() == 2)
#line 10613 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl2I_reg_risbg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl2I_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl2I_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl2I_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl2I_reg_risbg_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl2I_reg_risbg_rule, c+1)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMFP0) &&
        (
#line 10681 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 2
#line 10644 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMFP0] + DEFAULT_COST;
        DFA_PRODUCTION(IREGL, Repl2F_imm0_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, Repl2F_imm0_rule, c+1)
        DFA_PRODUCTION(RODDREGL, Repl2F_imm0_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, Repl2F_imm0_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, Repl2F_imm0_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, Repl2F_imm0_rule, c+1)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF) &&
        (
#line 10662 "src/hotspot/cpu/s390/s390.ad"
n->as_Vector()->length() == 2
#line 10659 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl2F_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl2F_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl2F_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl2F_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl2F_imm_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl2F_imm_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10646 "src/hotspot/cpu/s390/s390.ad"
VM_Version::has_FPSupportEnhancements() && n->as_Vector()->length() == 2
#line 10688 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl2F_reg_direct_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl2F_reg_direct_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl2F_reg_direct_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl2F_reg_direct_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl2F_reg_direct_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl2F_reg_direct_rule, c+1)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10631 "src/hotspot/cpu/s390/s390.ad"
!VM_Version::has_FPSupportEnhancements() && n->as_Vector()->length() == 2
#line 10717 "dfa_s390.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, Repl2F_reg_indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+MEMORY_REF_COST) {
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
      }
      if (STATE__NOT_YET_VALID(REVENREGL) || _cost[REVENREGL] > c+1) {
        DFA_PRODUCTION(REVENREGL, Repl2F_reg_indirect_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RODDREGL) || _cost[RODDREGL] > c+1) {
        DFA_PRODUCTION(RODDREGL, Repl2F_reg_indirect_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(ALLRODDREGL) || _cost[ALLRODDREGL] > c+1) {
        DFA_PRODUCTION(ALLRODDREGL, Repl2F_reg_indirect_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG1REGL) || _cost[RARG1REGL] > c+1) {
        DFA_PRODUCTION(RARG1REGL, Repl2F_reg_indirect_rule, c+1)
      }
      if (STATE__NOT_YET_VALID(RARG5REGL) || _cost[RARG5REGL] > c+1) {
        DFA_PRODUCTION(RARG5REGL, Repl2F_reg_indirect_rule, c+1)
      }
    }
}
void  State::_sub_Op_VectorReinterpret(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION(IREGL, reinterpret_rule, c)
        DFA_PRODUCTION(STACKSLOTL, regL_to_stkL_rule, c+MEMORY_REF_COST)
        DFA_PRODUCTION(REVENREGL, reinterpret_rule, c+1)
        DFA_PRODUCTION(RODDREGL, reinterpret_rule, c+1)
        DFA_PRODUCTION(ALLRODDREGL, reinterpret_rule, c+1)
        DFA_PRODUCTION(RARG1REGL, reinterpret_rule, c+1)
        DFA_PRODUCTION(RARG5REGL, reinterpret_rule, c+1)
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AbsI: { _sub_Op_AbsI(n);
    break;
  }
  case Op_AbsL: { _sub_Op_AbsL(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastDD: { _sub_Op_CastDD(n);
    break;
  }
  case Op_CastFF: { _sub_Op_CastFF(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastLL: { _sub_Op_CastLL(n);
    break;
  }
  case Op_CastVV: { _sub_Op_CastVV(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CMoveN: { _sub_Op_CMoveN(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_DivModI: { _sub_Op_DivModI(n);
    break;
  }
  case Op_DivModL: { _sub_Op_DivModL(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_HasNegatives: { _sub_Op_HasNegatives(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadD_unaligned: { _sub_Op_LoadD_unaligned(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadL_unaligned: { _sub_Op_LoadL_unaligned(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarCPUOrder: { _sub_Op_MemBarCPUOrder(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_OverflowAddI: { _sub_Op_OverflowAddI(n);
    break;
  }
  case Op_OverflowSubI: { _sub_Op_OverflowSubI(n);
    break;
  }
  case Op_OverflowAddL: { _sub_Op_OverflowAddL(n);
    break;
  }
  case Op_OverflowSubL: { _sub_Op_OverflowSubL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrCompressedCopy: { _sub_Op_StrCompressedCopy(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_StrInflatedCopy: { _sub_Op_StrInflatedCopy(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_VectorReinterpret: { _sub_Op_VectorReinterpret(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
